VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "InBlu_Point_3D"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'==================================================================================================================
' Description.....: Interface module to manage a point to rappresent on video
' File Name.......: InBlu_Point_3D.cls
' Data............: 12/11/2003
' Version.........: 1.0(32 bit).
' System..........: VB6,Windows 98.
' Written by......: Condor trade s.r.l.
' E-Mail..........: info@condorgroup.com
' web Site........: http://www.inblu.com
'==================================================================================================================

Option Explicit

'Local copy of X Property
Private mdblX As Double
'Local copy of Y Property
Private mdblY As Double
'Local copy of Z Property
Private mdblZ As Double
'Local copy of MarkerStyle Property
Private mstrMarkerStyle As String
'Local copy of MarkerColour Property
Private mlngMarkerColour As Long
'Local copy of MarkerSize Property
Private mdblMarkerSize As Double
'Local copy of Identification Property
Private mstrIdentification As Variant
'Local copy of Enabled Property
Private mbooEnabled As Boolean
'Local copy of Visible Property
Private mbooVisible As Boolean
'Local copy of Selected Property
Private mbooSelected As Boolean
'Local copy of Interpolant Property
Private mbooInterpolant As Boolean
'Local copy of Moveable Property
Private mbooMoveable As Boolean
'Local copy of Orientation Property
Private miagOrientation As Inblu_Angles
'Local copy of OffsetOrientation Property
Private miagOffsetOrientation As Inblu_Angles
'Local copy of Procedure Property
Private mlngProcedure As Long
'Local copy of OffsetX Property
Private mdblOffsetX As Double
'Local copy of OffsetY Property
Private mdblOffsetY As Double
'Local copy of OffsetZ Property
Private mdblOffsetZ As Double
'Local copy ToolDistance Property
Private mlngToolDistance As Long
'Local copy ToolNumber Property
Private mlngToolNumber As Long
'Local copy Open Delay
Private mdblOpenDelay As Double
'Local copy Close Delay
Private mdblCloseDelay  As Double
'Local copy of BaseZ property
Private mdblBaseZ As Double
'Local copy of BaseY property
Private mdblBaseY As Double
'Local copy of BaseX property
Private mdblBaseX As Double
'Local copy of Accuracy property
Private mlngAccuracy As Long
'Local copy of StopProcedureTime property
Private mdblStopProcedureTime As Double
'------------------------------------------------------------------------
'Properties
'------------------------------------------------------------------------

Public Property Get Accuracy() As Long
'Return the Accuracy of point
    Accuracy = mlngAccuracy
End Property

Public Property Let Accuracy(ByVal NewValue As Long)
'Set the Accuracy of point
    mlngAccuracy = NewValue
End Property

Public Property Get StopProcedureTime() As Double
    StopProcedureTime = mdblStopProcedureTime
End Property

Public Property Let StopProcedureTime(ByVal NewValue As Double)
    mdblStopProcedureTime = NewValue
End Property

Public Property Get CloseDelay() As Long
'Return the Close delay of point
    CloseDelay = mdblCloseDelay
End Property

Public Property Let CloseDelay(ByVal NewValue As Long)
'Set the Close Delay of point
    mdblCloseDelay = NewValue
End Property

Public Property Get OpenDelay() As Long
'Return the Open Delay of point
    OpenDelay = mdblOpenDelay
End Property

Public Property Let OpenDelay(ByVal NewValue As Long)
'Set the Open Delay of point
    mdblOpenDelay = NewValue
End Property

Public Property Get ToolDistance() As Long
'Return the Tool distance of point
    ToolDistance = mlngToolDistance
End Property

Public Property Let ToolDistance(ByVal NewValue As Long)
'Set the Tool distance of point
    mlngToolDistance = NewValue
End Property

Public Property Get ToolNumber() As Long
'Return the Tool Number of point
    ToolNumber = mlngToolNumber
End Property

Public Property Let ToolNumber(ByVal NewValue As Long)
'Set the Tool Number of point
    mlngToolNumber = NewValue
End Property

Public Property Get Procedure() As Long
'Return the procedure of point
    Procedure = mlngProcedure
End Property

Public Property Let Procedure(ByVal NewValue As Long)
'Set the procedure of point
    mlngProcedure = NewValue
End Property

Public Property Get Orientation() As Inblu_Angles
'Return orientation of point
    Set Orientation = miagOrientation
End Property

Public Property Let Orientation(ByVal NewValue As Inblu_Angles)
'Set orientation of point
    Set miagOrientation = NewValue
End Property

Public Property Get OffsetOrientation() As Inblu_Angles
'Return orientation of point
    Set OffsetOrientation = miagOffsetOrientation
End Property

Public Property Let OffsetOrientation(ByVal NewValue As Inblu_Angles)
'Set orientation of point
    Set miagOffsetOrientation = NewValue
End Property

Public Property Get Moveable() As Boolean
'Return if a point is interpolated or not
    Moveable = mbooMoveable
End Property

Public Property Let Moveable(ByVal vNewValue As Boolean)
'Set if a point is interpolated or not
    mbooMoveable = vNewValue
End Property

Public Property Get Interpolant() As Boolean
'Return if a point is interpolated or not
    Interpolant = mbooInterpolant
End Property

Public Property Let Interpolant(ByVal vNewValue As Boolean)
'Set if a point is interpolated or not
    mbooInterpolant = vNewValue
End Property

Public Property Let Z(ByVal vData As Double)
'Set Z Coordinate of point
    mdblZ = vData
End Property

Public Property Get Z() As Double
'Return Z Coordinate of point
    mdblZ = mdblBaseZ + mdblOffsetZ
    Z = mdblZ
End Property

Public Property Let Y(ByVal vData As Double)
'Set Y Coordinate of point
    mdblY = vData
End Property

Public Property Get Y() As Double
'Return Y Coordinate of point
    mdblY = mdblBaseY + mdblOffsetY
    Y = mdblY
End Property

Public Property Let X(ByVal vData As Double)
'Set X Coordinate of point
    mdblX = vData
End Property

Public Property Get X() As Double
'Return X Coordinate of point
    mdblX = mdblBaseX + mdblOffsetX
    X = mdblX
End Property

Public Property Let BaseZ(ByVal vData As Double)
'Set Z Coordinate of point
    mdblBaseZ = vData
End Property

Public Property Get BaseZ() As Double
'Return Z Coordinate of point
    BaseZ = mdblBaseZ
End Property

Public Property Let BaseY(ByVal vData As Double)
'Set Y Coordinate of point
    mdblBaseY = vData
End Property

Public Property Get BaseY() As Double
'Return Y Coordinate of point
    BaseY = mdblBaseY
End Property

Public Property Let BaseX(ByVal vData As Double)
'Set X Coordinate of point
    mdblBaseX = vData
End Property

Public Property Get BaseX() As Double
'Return X Coordinate of point
    BaseX = mdblBaseX
End Property

Public Property Let Selected(ByVal vData As Boolean)
'Set if a point is selected by user
    mbooSelected = vData
End Property

Public Property Get Selected() As Boolean
'Return the status of a point,it is true if point has been selected by user previously
    Selected = mbooSelected
End Property

Public Property Let Visible(ByVal vData As Boolean)
'Set if a point is visible to a user
    mbooVisible = vData
End Property

Public Property Get Visible() As Boolean
'Return if a point is visible or not
    Visible = mbooVisible
End Property

Public Property Let Enabled(ByVal vData As Boolean)
'Set if point is working or not
    mbooEnabled = vData
End Property

Public Property Get Enabled() As Boolean
'Return if point is working or not
    Enabled = mbooEnabled
End Property

Public Property Let Identification(ByVal vData As Variant)
'??????????????????????????????????????????
    mstrIdentification = vData
End Property

Public Property Get Identification() As Variant
'??????????????????????????????????????????
    Identification = mstrIdentification
End Property

Public Property Let MarkerSize(ByVal vData As Double)
'Set the marker dimension of point
    mdblMarkerSize = vData
End Property

Public Property Get MarkerSize() As Double
'Return the marker dimension of point
    MarkerSize = mdblMarkerSize
End Property

Public Property Let MarkerColour(ByVal vData As Long)
'Set the colour of point
    mlngMarkerColour = vData
End Property

Public Property Get MarkerColour() As Long
'Return the colour of point
    MarkerColour = mlngMarkerColour
End Property

Public Property Let MarkerStyle(ByVal vData As String)
'Set the rappresentation's style of point
    mstrMarkerStyle = vData
End Property

Public Property Get MarkerStyle() As String
'Return the rappresentation's style of point
    MarkerStyle = mstrMarkerStyle
End Property

Public Property Let OffsetX(ByVal vData As Double)
'Set X Coordinate of point
    mdblOffsetX = vData
End Property

Public Property Get OffsetX() As Double
'Return X Coordinate of point
    OffsetX = mdblOffsetX
End Property

Public Property Let OffsetZ(ByVal vData As Double)
'Set X Coordinate of point
    mdblOffsetZ = vData
End Property

Public Property Get OffsetZ() As Double
'Return X Coordinate of point
    OffsetZ = mdblOffsetZ
End Property

Public Property Let OffsetY(ByVal vData As Double)
'Set X Coordinate of point
    mdblOffsetY = vData
End Property

Public Property Get OffsetY() As Double
'Return X Coordinate of point
    OffsetY = mdblOffsetY
End Property


'------------------------------------------------------------------------
'Methods
'------------------------------------------------------------------------

Public Sub MoveDelta(ByVal DeltaX As Double, ByVal DeltaY As Double, ByVal DeltaZ As Double)
    'Update properties adding
    'new values
    OffsetX = OffsetX + DeltaX
    OffsetY = OffsetY + DeltaY
    OffsetZ = OffsetZ + DeltaZ
End Sub

Public Sub MoveTo(ByVal NewX As Double, ByVal NewY As Double, ByVal NewZ As Double)
    'Update properties with
    'new values
    OffsetX = 0
    OffsetY = 0
    OffsetZ = 0
    mdblBaseX = NewX
    mdblBaseY = NewY
    mdblBaseZ = NewZ
End Sub

Public Function InfoSerializer(InfoToSerialize As String) As String
'This function is used to serialize in a string the infomation of the class

    'Declarations
    Dim TmpSerializedInfo As String
    
    Dim GeomCalc As Inblu_Geom_Calculator
    Dim RFA(1 To 4, 1 To 4) As Double
    Dim RFT(1 To 4, 1 To 4) As Double
    Dim RFAT() As Double
    Dim RFOAT() As Double
    Dim ROA() As Double
    Dim ROAT() As Double
    Dim RotO(1 To 4, 1 To 4) As Double
    Dim RotA(1 To 4, 1 To 4) As Double
    Dim RotT(1 To 4, 1 To 4) As Double
    Dim RotX(1 To 4, 1 To 4) As Double
    Dim RotY(1 To 4, 1 To 4) As Double
    Dim RotZ(1 To 4, 1 To 4) As Double
    Dim RZY() As Double
    Dim RZYX() As Double
    Dim ToSendPoint As InBlu_Point_3D
    Dim RTot() As Double
    Dim Origin As InBlu_Point_3D
    Dim Res As String
    Dim Pos As Long
    
    Select Case InfoToSerialize
        Case "Coordinate"
            Pos = InStr(1, Str(mdblBaseX), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblBaseX), Pos + 2)
            Else
                Res = Str(mdblBaseX)
            End If
            TmpSerializedInfo = Trim(Res) & ";"
            Pos = InStr(1, Str(mdblBaseY), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblBaseY), Pos + 2)
            Else
                Res = Str(mdblBaseY)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(mdblBaseZ), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblBaseZ), Pos + 2)
            Else
                Res = Str(mdblBaseZ)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(miagOrientation.First), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOrientation.First), Pos + 2)
            Else
                Res = Str(miagOrientation.First)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(miagOrientation.Second), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOrientation.Second), Pos + 2)
            Else
                Res = Str(miagOrientation.Second)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(miagOrientation.Third), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOrientation.Third), Pos + 2)
            Else
                Res = Str(miagOrientation.Third)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
'            TmpSerializedInfo = Str(mdblBaseX) & ";" & Str(mdblBaseY) & ";" & Str(mdblBaseZ) & ";" & Str(miagOrientation.First) & ";" & Str(miagOrientation.Second) & ";" & Str(miagOrientation.Third) & ";"
        Case "OffsetTranslation"
            Pos = InStr(1, Str(mdblOffsetX), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblOffsetX), Pos + 2)
            Else
                Res = Str(mdblOffsetX)
            End If
            TmpSerializedInfo = Trim(Res) & ";"
            Pos = InStr(1, Str(mdblOffsetY), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblOffsetY), Pos + 2)
            Else
                Res = Str(mdblOffsetY)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(mdblOffsetZ), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblOffsetZ), Pos + 2)
            Else
                Res = Str(mdblOffsetZ)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
'            TmpSerializedInfo = Str(mdblOffsetX) & ";" & Str(mdblOffsetY) & ";" & Str(mdblOffsetZ) & ";"
        Case "OffsetRotation"
            Pos = InStr(1, Str(miagOffsetOrientation.First), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOffsetOrientation.First), Pos + 2)
            Else
                Res = Str(miagOffsetOrientation.First)
            End If
            TmpSerializedInfo = Trim(Res) & ";"
            Pos = InStr(1, Str(miagOffsetOrientation.Second), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOffsetOrientation.Second), Pos + 2)
            Else
                Res = Str(miagOffsetOrientation.Second)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(miagOffsetOrientation.Third), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOffsetOrientation.Third), Pos + 2)
            Else
                Res = Str(miagOffsetOrientation.Third)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
'            TmpSerializedInfo = Str(miagOffsetOrientation.First) & ";" & Str(miagOffsetOrientation.Second) & ";" & Str(miagOffsetOrientation.Third) & ";"
        Case "Distance"
            TmpSerializedInfo = Trim(Str(mlngToolDistance))
        Case "Tool"
            TmpSerializedInfo = Trim(Str(mlngToolNumber))
        Case "Procedure"
            TmpSerializedInfo = Trim(Str(mlngProcedure))
        Case "OpenDelay"
            TmpSerializedInfo = Trim(Str(mdblOpenDelay))
        Case "CloseDelay"
            TmpSerializedInfo = Trim(Str(mdblCloseDelay))
        Case "Speed"
            TmpSerializedInfo = Trim(Str(Read_Speed_Associations(mlngMarkerColour)))
        Case "Accuracy"
            TmpSerializedInfo = Trim(Str(mlngAccuracy))
        Case "StopProcedureTime"
            TmpSerializedInfo = Trim(Str(mdblStopProcedureTime))
        Case "ALL"
            Pos = InStr(1, Str(mdblBaseX), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblBaseX), Pos + 2)
            Else
                Res = Str(mdblBaseX)
            End If
            TmpSerializedInfo = Trim(Res) & ";"
            Pos = InStr(1, Str(mdblBaseY), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblBaseY), Pos + 2)
            Else
                Res = Str(mdblBaseY)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(mdblBaseZ), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblBaseZ), Pos + 2)
            Else
                Res = Str(mdblBaseZ)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(miagOrientation.First), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOrientation.First), Pos + 2)
            Else
                Res = Str(miagOrientation.First)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(miagOrientation.Second), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOrientation.Second), Pos + 2)
            Else
                Res = Str(miagOrientation.Second)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(miagOrientation.Third), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOrientation.Third), Pos + 2)
            Else
                Res = Str(miagOrientation.Third)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(mdblOffsetX), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblOffsetX), Pos + 2)
            Else
                Res = Str(mdblOffsetX)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(mdblOffsetY), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblOffsetY), Pos + 2)
            Else
                Res = Str(mdblOffsetY)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(mdblOffsetZ), ".")
            If Pos <> 0 Then
                Res = Left(Str(mdblOffsetZ), Pos + 2)
            Else
                Res = Str(mdblOffsetZ)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(miagOffsetOrientation.First), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOffsetOrientation.First), Pos + 2)
            Else
                Res = Str(miagOffsetOrientation.First)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(miagOffsetOrientation.Second), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOffsetOrientation.Second), Pos + 2)
            Else
                Res = Str(miagOffsetOrientation.Second)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            Pos = InStr(1, Str(miagOffsetOrientation.Third), ".")
            If Pos <> 0 Then
                Res = Left(Str(miagOffsetOrientation.Third), Pos + 2)
            Else
                Res = Str(miagOffsetOrientation.Third)
            End If
            TmpSerializedInfo = TmpSerializedInfo & Trim(Res) & ";"
            TmpSerializedInfo = TmpSerializedInfo & Trim(Str(mlngToolDistance)) & ";"
            TmpSerializedInfo = TmpSerializedInfo & Trim(Str(mlngToolNumber)) & ";"
            TmpSerializedInfo = TmpSerializedInfo & Trim(Str(mlngProcedure)) & ";"
            TmpSerializedInfo = TmpSerializedInfo & Trim(Str(mdblOpenDelay)) & ";"
            TmpSerializedInfo = TmpSerializedInfo & Trim(Str(mdblCloseDelay)) & ";"
            TmpSerializedInfo = TmpSerializedInfo & Trim(Str(Read_Speed_Associations(mlngMarkerColour))) & ";"
            TmpSerializedInfo = TmpSerializedInfo & Trim(Str(mlngAccuracy)) & ";"
            TmpSerializedInfo = TmpSerializedInfo & Trim(Str(mdblStopProcedureTime)) & ";"

'            TmpSerializedInfo = Str(mdblBaseX) & " ;" & Str(mdblBaseY) & " ;" & Str(mdblBaseZ) & " ;" & Str(miagOrientation.First) & " ;" & Str(miagOrientation.Second) & " ;" & Str(miagOrientation.Third) _
'            & " ;" & Str(mdblOffsetX) & " ;" & Str(mdblOffsetY) & " ;" & Str(mdblOffsetZ) & " ;" & Str(miagOffsetOrientation.First) & " ;" & Str(miagOffsetOrientation.Second) & " ;" & Str(miagOffsetOrientation.Third) _
'            & " ;" & Str(mlngToolDistance) & " ;" & Str(mlngToolNumber) & " ;" & Str(mlngProcedure) & " ;" & Str(mdblOpenDelay) & " ;" & Str(mdblCloseDelay) & " ;" & _
'            Str(Read_Speed_Associations(mlngMarkerColour)) & " ;" & Str(mlngAccuracy) & " ;" & Str(mdblStopProcedureTime) & " ;"
    End Select
    
    InfoSerializer = TmpSerializedInfo
    
'    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'    Set GeomCalc = New Inblu_Geom_Calculator
'    Set ToSendPoint = New InBlu_Point_3D
'    Set Origin = New InBlu_Point_3D
'
'    'Orientation
'    GeomCalc.RotY 180, RFA()
'    GeomCalc.RotZ 0, RFT()
'    RFAT() = MMol(RFT(), RFA())
'    GeomCalc.RotZ miagOrientation.First, RotO()
'    GeomCalc.RotY miagOrientation.Second, RotA()
'    GeomCalc.RotZ miagOrientation.Third, RotT()
'    ROA() = MMol(RotO(), RotA())
'    ROAT() = MMol(ROA(), RotT())
'    RFOAT() = MMol(RFAT(), ROAT())
'    GeomCalc.RotX -miagOffsetOrientation.First, RotX()
'    GeomCalc.RotY miagOffsetOrientation.Second, RotY()
'    GeomCalc.RotZ -miagOffsetOrientation.Third, RotZ()
'    RZY() = MMol(RotZ(), RotY())
'    RZYX() = MMol(RZY(), RotX())
'    RTot() = MMol(RZYX(), RFOAT())
'
'    'Position
'    ToSendPoint.BaseX = mdblBaseX + mdblOffsetX
'    ToSendPoint.BaseY = mdblBaseY + mdblOffsetY
'    ToSendPoint.BaseZ = mdblBaseZ + mdblOffsetZ
'    ToSendPoint.Orientation.AngleType = "ZYZ"
'    GeomCalc.GetPointByTrans RTot(), Origin, ToSendPoint.Orientation
'
'    Set GeomCalc = Nothing
'    Set ToSendPoint = Nothing
'    Set Origin = Nothing
'
'
'    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

End Function

Public Sub CopyProperties(Destination As InBlu_Point_3D)
'Function to copy the properties
'of point in an other point
'INPUT\OUTPUT PARAMETER:
'                       Destination:Point where store the properties

    With Destination
    
        .Enabled = mbooEnabled
        .Identification = mstrIdentification
        .Interpolant = mbooInterpolant
        .MarkerColour = mlngMarkerColour
        .MarkerSize = mdblMarkerSize
        .MarkerStyle = mstrMarkerStyle
        .Moveable = mbooMoveable
        .Selected = mbooSelected
        .Visible = mbooVisible
        .Procedure = mlngProcedure
        .ToolNumber = mlngToolNumber
        .ToolDistance = mlngToolDistance
        .OpenDelay = mdblOpenDelay
        .CloseDelay = mdblCloseDelay
        .Accuracy = mlngAccuracy
        .StopProcedureTime = mdblStopProcedureTime
        
    End With
    
End Sub

Public Sub Draw(ByVal Context As Object)
'Function to draw a point
'INPUT PARAMETER:
'               Context : Where to draw this point

    Dim OForeColor As Long 'Original Color of Draw
    Dim OFontSize As Long 'Original Dimension of Rappresentation
    Dim OCurX As Double 'Original X Coordinate of Form
    Dim OCurY As Double 'Original Y Coordinate of Form
    Dim CosAlpha As Double, CosBeta As Double, CosGamma As Double
    Dim SinAlpha As Double, SinBeta As Double, SinGamma As Double
    Dim TempRotZ As Double 'Temporary variable for Z rotation
    Dim TempRotY As Double 'Temporary variable for Y rotation

    
    'Saving Original points in temporary variables
    OForeColor = Context.ForeColor
    OFontSize = Context.FontSize
    OCurX = Context.CurrentX
    OCurY = Context.CurrentY
    
    '****************************************************
    'ATTENTION: Angle for Cos and Sin function
    'must to be expressed in Radiant.In our case
    'the user put an angle in degrees and then
    'is converted in radiant by formule :Angle*(Pi/180)
    '****************************************************
    CosAlpha = Cos(Context.SpinScreenYAngle * (PiGreco / 180))
    SinAlpha = Sin(Context.SpinScreenYAngle * (PiGreco / 180))
    CosBeta = Cos(Context.SpinScreenXAngle * (PiGreco / 180))
    SinBeta = Sin(Context.SpinScreenXAngle * (PiGreco / 180))
       
    'AngleZRotation=alpha
    'AngleYRotation=beta
    'Xc=X center
    'Yc=Y center
    'Zc=Z center
    'Xo,Yo,Zo= Original coordinates
    'New Y=[(Yc+(Yo-Yc)*cos(alpha))+(Xc+(Xo-Xc)*sin(alpha))]
    TempRotZ = (Context.YCenter + ((mdblY - Context.YCenter) * CosAlpha)) + _
                (((mdblX - Context.Xcenter) * SinAlpha)) 'Context.XCenter +
                    
    'New Z=[((Yo-Yc)*sin(alpha))*sin(beta)-((Xo-Xc)*cos(alpha))*sin(beta)+(Zc+(Zo-Zc)*cos(beta))]
    TempRotY = (((mdblY - Context.YCenter) * SinAlpha) * SinBeta) - (((mdblX - Context.Xcenter) * CosAlpha) * SinBeta) + _
                (Context.ZCenter + (mdblZ - Context.ZCenter) * CosBeta)

    
    'Common settings
    Context.ForeColor = mlngMarkerColour
    Context.FontSize = mdblMarkerSize
    
    'If Marker is a circle is called on Circle method,
    'in any other case the marker is simply printed on the
    'screen
    Select Case mstrMarkerStyle:
    
            Case "o":
                                    
                    Context.Circle_ Val(TempRotZ), Val(TempRotY), Val(mdblMarkerSize), mlngMarkerColour
            
            Case Else:
                    
                    Context.CurrentX = TempRotZ - (Context.TextWidth(mstrMarkerStyle) / 2)
                    Context.CurrentY = TempRotY - (Context.TextHeight(mstrMarkerStyle) / 2)
                    
                    Context.Print_ mstrMarkerStyle
                    
    End Select
    
    'Setting again original values of properties
    Context.ForeColor = OForeColor
    Context.FontSize = OFontSize
    Context.CurrentX = OCurX
    Context.CurrentY = OCurY

End Sub

Public Sub Rotate(ByVal Context As Object, Transformation() As Double)
'Function to rotate a point around a center
'INPUT PARAMETER:
'               Context:Container of point
'               Transformation():Matrix of rotation
    
    'Declarations
    Dim CoordPointTemp(1 To 4, 1) As Double
    Dim RotatePointTemp() As Double
    Dim I As Long, K As Long
    Dim CenterMatrix(1 To 4, 1) As Double
    Dim Difference() As Double
    Dim Add() As Double
    
    
    CenterMatrix(1, 1) = Context.RotXCenter
    CenterMatrix(2, 1) = Context.RotYCenter
    CenterMatrix(3, 1) = Context.RotZCenter
    CenterMatrix(4, 1) = 1
    
    CoordPointTemp(1, 1) = mdblX
    CoordPointTemp(2, 1) = mdblY
    CoordPointTemp(3, 1) = mdblZ
    CoordPointTemp(4, 1) = 1
    
    Difference() = MDif(CoordPointTemp(), CenterMatrix())
    
    Difference(4, 1) = 1
    
    'Coordinates of point rotated
    RotatePointTemp() = MMol(Transformation(), Difference())
    
    Add() = MSom(RotatePointTemp(), CenterMatrix())
    
    'Update the coordinates
    mdblX = Add(1, 1)
    mdblY = Add(2, 1)
    mdblZ = Add(3, 1)
    
End Sub

Private Sub Class_Initialize()

    'Default values of properties
    mstrMarkerStyle = "o"
    mlngMarkerColour = vbRed
    mdblMarkerSize = 3
    mstrIdentification = ""
    mbooEnabled = True
    mbooVisible = True
    mbooSelected = False
    mbooInterpolant = False
    mbooMoveable = True
    mlngProcedure = -1
    mlngToolDistance = 0
    mlngToolNumber = -1
    mdblOpenDelay = 0
    mdblCloseDelay = 0
    mlngAccuracy = 1000
    mdblStopProcedureTime = 0
    Set miagOrientation = New Inblu_Angles
    Set miagOffsetOrientation = New Inblu_Angles

End Sub

Private Sub Class_Terminate()
    Set miagOrientation = Nothing
    Set miagOffsetOrientation = Nothing
End Sub
