VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "InBlu_Shape_3D"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'==================================================================================================================
' Description.....: Interface module to manage a shape to rappresent on video
' File Name.......: InBlu_Shape_3D.cls
' Data............: 27/11/2003
' Version.........: 1.0(32 bit).
' System..........: VB6,Windows 98.
' Written by......: Condor trade s.r.l.
' E-Mail..........: info@condorgroup.com
' web Site........: http://www.inblu.com
'==================================================================================================================

Option Explicit

'*************************************************************************
'These array are used to speed up the computation of Pc,because instancing
'properties of a class ( InBlu_Point_3D ) all operation are delayed
'*************************************************************************
'Splines variables
'Array with interpolated points
Private ArraySplines As Points
'Array of colour pointers of interpolated points(keep trace of colour change in the shape)
Private ArraySplinesPointers() As Long
'Array of markers of original points in the interpolated points
Private ArraySplinesMarkers() As String
'Array for colour of interpolated points
Private ArraySplinesColour() As Long
'Array of markers of original points in the interpolated points
Private ArraySplinesMarkersSize() As Long

'Line Variables
'Array for colour of original points
Private ArrayLinesColour() As Long
'Array with original points
Private ArrayLines As Points
'Array of colour pointers of original points(keep trace of colour change in the shape)
Private ArrayLinesPointers() As Long
'Array of markers of original points
Private ArrayLinesMarkers() As String
'Array of markers of original points
Private ArrayLinesMarkersSize() As Long

'Flags
'Flag that indicate if a shape is already interpolated
Private AlreadyInterpolated As Boolean
'Flag that indicate if a shape is already been drawn
Private AlreadyLined As Boolean
'Flag that indicate if for the shape is already calculate MinX value
Private AlreadyMinX As Boolean
'Flag that indicate if for the shape is already calculate MinY value
Private AlreadyMinY As Boolean
'Flag that indicate if for the shape is already calculate MinZ value
Private AlreadyMinZ As Boolean
'Flag that indicate if for the shape is already calculate MaxX value
Private AlreadyMaxX As Boolean
'Flag that indicate if for the shape is already calculate MaxY value
Private AlreadyMaxY As Boolean
'Flag that indicate if for the shape is already calculate MaxZ value
Private AlreadyMaxZ As Boolean
'Flag that indicate if for the shape is already calculate XCenter value
Private AlreadyXCenter As Boolean
'Flag that indicate if for the shape is already calculate YCenter value
Private AlreadyYCenter As Boolean
'Flag that indicate if for the shape is already calculate ZCenter value
Private AlreadyZCenter As Boolean

'Generic Variables
'Variable that keep trace of previous spin angle on Y side of the screen
Private PrevYAngle As Double
'Variable that keep trace of previous spin angle on X side of the screen
Private PrevXAngle As Double
'Variable that keep trace of previous spin angle on X side of the screen
Private PrevXSAngle As Double
'Temporary array used to calculate minimum and maximum values of coordinates of shape
Private TempArray() As Variant
'Local Variable to create a collection
Private mPoints As Collection
'Local variable that contains the coordinates of
'points not rappresented on screen
Private CoordinateOutOfPlane As Points

'Properties local variables:

'Local copy of PointOnEdge Property
Private mlngPointOnEdge As Long
'Local copy of MarkerColour Property
Private mlngMarkerColour As Long
'Local copy of MarkerSize Property
Private mlngMarkerSize As Long
'Local copy of MarkerStyle Property
Private mstrMarkerStyle As String
'Local copy of XShapeCenter Property
Private mvarXCenter As Double
'Local copy of YShapeCenter Property
Private mvarYCenter As Double
'Local copy of ZShapeCenter Property
Private mvarZCenter As Double
'Local copy of Visible property
Private mbooVisible As Boolean
'Local copy of LineStyle property
Private mlngLineStyle As DrawStyleConstants
'Local copy of LineWidth property
Private mlngLineWidth As Long
'Local copy of LineColour property
Private mlngLineColour As Long
'Local copy of Selected property
Private mbooSelected As Boolean
'Local copy of MinimumX property
Private mvarMinimumX As Double
'Local copy of MinimumY property
Private mvarMinimumY As Double
'Local copy of MinimumZ property
Private mvarMinimumZ As Double
'Local copy of MaximumX property
Private mvarMaximumX As Double
'Local copy of MaximumY property
Private mvarMaximumY As Double
'Local copy of MaximumZ property
Private mvarMaximumZ As Double
'Local copy of RappresentationMode property
Private mstyRappresentationMode As String
'Local copy of NumberInterpolatedPoints property
Private mlngNumberInterpolatedPoints As Long
'Local copy of Selected property
Private mvarSelected As Boolean
'Local copy of PointsNumber property
Private mlngPointsNumber As Long
'Local copy of RotXCenter property
Private mdblRotXCenter As Double
'Local copy of RotYCenter property
Private mdblRotYCenter As Double
'Local copy of RotZCenter property
Private mdblRotZCenter As Double
'Local copy of Closed property
Private mbooClosed As Boolean
'Local copy of Identification property
Private mwtyIdentification As ShapeType
'Local copy of Procedure Property
Private mstrProcedure As String
'Local copy of Closed property
Private mbooMoveable As Boolean

'UDT used to draw a shape on video
Private Type Points
    X() As Double
    Y() As Double
    Z() As Double
End Type

'Specify what rappresent the shape
'for user
Public Enum ShapeType
    Graphical = 0
    Sprayer
    Colata
    Cutting
End Enum

'------------------------------------------------------------------------
'Properties
'------------------------------------------------------------------------

Public Property Get Procedure() As String
'Return the procedure of point
    
    'Declarations
    Dim I As Long, FindDifferent As Boolean
    For I = 1 To mPoints.Count
        If mPoints.Item(I).Procedure <> mstrProcedure Then
            FindDifferent = True
        End If
    Next I
    If FindDifferent = False Then
        Procedure = mstrProcedure
    Else
        'MultiProcedure
        'procedure=
    End If
End Property

Public Property Let Procedure(ByVal NewValue As String)
'Set the procedure of point

    'Declarations
    Dim I As Long

    For I = 1 To mPoints.Count
        mPoints.Item(I).Procedure = NewValue
    Next I
    mstrProcedure = NewValue
End Property

Public Property Get PointOnEdge() As Long
'Return selected spline point's index
    PointOnEdge = mlngPointOnEdge
End Property

Public Property Let PointOnEdge(ByVal NewValue As Long)
    mlngPointOnEdge = NewValue
End Property

Public Property Get Identification() As ShapeType
'Return the type of shape
    Identification = mwtyIdentification
End Property

Public Property Let Identification(ByVal NewValue As ShapeType)
'Set shape's type
    mwtyIdentification = NewValue
    If mwtyIdentification <> Graphical Then
        mlngLineColour = 0
    End If
End Property

Public Property Get Closed() As Boolean
'Return if a shape is closed
    Closed = mbooClosed
End Property

Public Property Let Closed(ByVal NewValue As Boolean)
'Set if a shape is closed
    mbooClosed = NewValue
End Property

Public Property Get Moveable() As Boolean
'Return if a shape is Moveable
    Moveable = mbooMoveable
End Property

Public Property Let Moveable(ByVal NewValue As Boolean)
'Set if a shape is Moveable

    'Declarations
    Dim I As Long
    
    mbooMoveable = NewValue
    For I = 1 To mPoints.Count
        mPoints.Item(I).Moveable = NewValue
    Next I
End Property

Public Property Get MarkerColour() As Long
'Return the value of common markercolour
    
    'Declarations
    Dim I As Long, FindDifferentColour As Boolean
    
    'Set new marker color for all points
    For I = 1 To mPoints.Count
        If mPoints.Item(I).MarkerColour <> mlngMarkerColour Then
            FindDifferentColour = True
            mlngMarkerColour = 0
            Exit For
        End If
    Next I
    MarkerColour = mlngMarkerColour
End Property

Public Property Let MarkerColour(vData As Long)
'Set the common value of markercolour

    'Declarations
    Dim I As Long
    
    mlngMarkerColour = vData
    'Set new marker color for all points
    For I = 1 To mPoints.Count
        mPoints.Item(I).MarkerColour = vData
    Next I
End Property

Public Property Get MarkerSize() As Long
'Return the value of common MarkerSize
    MarkerSize = mlngMarkerSize
End Property

Public Property Let MarkerSize(vData As Long)
'Set the value of common MarkerSize

    'Declarations
    Dim I As Long
    
    mlngMarkerSize = vData
    'Set new marker dimension for all points
    For I = 1 To PointsNumber
        mPoints.Item(I).MarkerSize = vData
    Next I
End Property

Public Property Get MarkerStyle() As String
'Return the value of common MarkerStyle
    MarkerStyle = mstrMarkerStyle
End Property

Public Property Let MarkerStyle(vData As String)
'Set the value of common MarkerStyle

    'Declarations
    Dim I As Long
    
    mstrMarkerStyle = vData
    'Set new marker style for all points
    For I = 1 To PointsNumber
        mPoints.Item(I).MarkerStyle = vData
    Next I
End Property

Public Property Get RotZCenter() As Double
'Return the value of Z coordinate center
    RotZCenter = mdblRotZCenter
End Property

Public Property Let RotZCenter(vData As Double)
'Return the value of Z coordinate center
    mdblRotZCenter = vData
End Property

Public Property Get RotYCenter() As Double
'Return the value of Y coordinate center
    
    RotYCenter = mdblRotYCenter

End Property

Public Property Let RotYCenter(vData As Double)
'Return the value of Z coordinate center
    mdblRotYCenter = vData
End Property

Public Property Get RotXCenter() As Double
'Return the value of X coordinate center
    RotXCenter = mdblRotXCenter
End Property

Public Property Let RotXCenter(vData As Double)
'Return the value of Z coordinate center
    mdblRotXCenter = vData
End Property

Public Property Let NumberInterpolatedPoints(ByVal vData As Long)
'Set the number of points built by spline function
    mlngNumberInterpolatedPoints = vData
End Property

Public Property Get NumberInterpolatedPoints() As Long
'Return the number of points built by spline function
    NumberInterpolatedPoints = mlngNumberInterpolatedPoints
End Property

Public Property Get ZCenter() As Double
'Return the value of Z coordinate center
    If AlreadyZCenter = False Then
        mvarZCenter = Val(Find_Center(MinimumZ, MaximumZ))
        'Find_ZCenter
    End If
    ZCenter = mvarZCenter
End Property

Public Property Get YCenter() As Double
'Return the value of Y coordinate center
    If AlreadyYCenter = False Then
        mvarYCenter = Val(Find_Center(MinimumY, MaximumY))
        'Find_YCenter
    End If
    YCenter = mvarYCenter
End Property

Public Property Get Xcenter() As Double
'Return the value of X coordinate center
    If AlreadyXCenter = False Then
        mvarXCenter = Val(Find_Center(MinimumX, MaximumX))
        'Find_XCenter
    End If
    Xcenter = mvarXCenter
End Property

Public Property Let LineWidth(ByVal vData As Long)
'Set line dimension
    mlngLineWidth = vData
End Property

Public Property Get LineWidth() As Long
'Return line dimension
    LineWidth = mlngLineWidth
End Property

Public Property Let LineStyle(ByVal vData As DrawStyleConstants)
'Set line style (example:Dot,dot and line,....)
    mlngLineStyle = vData
End Property

Public Property Get LineStyle() As DrawStyleConstants
'Return line style (example:Dot,dot and line,....)
    LineStyle = mlngLineStyle
End Property

Public Property Let LineColour(ByVal vData As DrawStyleConstants)
'Set line colour's
    mlngLineColour = vData
End Property

Public Property Get LineColour() As Long
'Return line colour's
    LineColour = mlngLineColour
End Property

Public Property Let RappresentationMode(ByVal vData As Style)
'Set style of rappresentation of shape (example:Spline,Marker,..)
'    MsgBox "Un punto non  rappresentabile con delle linee", vbInformation, "System Communication"
    mstyRappresentationMode = vData
    'Set to false all computation flag
    AlreadyInterpolated = False
    AlreadyLined = False
End Property

Public Property Get RappresentationMode() As Style
'Return style of rappresentation of shape (example:Spline,Marker,..)
    RappresentationMode = mstyRappresentationMode
End Property

Public Property Get MaximumZ() As Double
'Return Maximum value of Z coordinate of shape
    
    'Declarations
    Dim I As Long, TempArr() As Double

    If AlreadyMaxZ = False Then
        AlreadyZCenter = False
        ReDim TempArr(mPoints.Count - 1)
        For I = 1 To mPoints.Count
            TempArr(I - 1) = mPoints.Item(I).Z
        Next I
        'Find minimum values of X coordinate of shape
        mvarMaximumZ = Val(Find_Max_In_Array(TempArr()))
        AlreadyMaxZ = True
    End If
    MaximumZ = mvarMaximumZ
End Property

Public Property Get MaximumY() As Double
'Return Maximum value of Y coordinate of shape
    
    'Declarations
    Dim I As Long, TempArr() As Double
    
    If AlreadyMaxY = False Then
    
        AlreadyYCenter = False
        
        ReDim TempArr(mPoints.Count - 1)
        
        For I = 1 To mPoints.Count
        
            TempArr(I - 1) = mPoints.Item(I).Y
        
        Next I
        
        'Find minimum values of X coordinate of shape
        mvarMaximumY = Val(Find_Max_In_Array(TempArr()))
        
        AlreadyMaxY = True
        
    End If
    MaximumY = mvarMaximumY

End Property

Public Property Get MaximumX() As Double
'Return Maximum value of X coordinate of shape
    
    'Declarations
    Dim I As Long, TempArr() As Double
    
    If AlreadyMaxX = False Then
    
        AlreadyXCenter = False

        ReDim TempArr(mPoints.Count - 1)
        
        For I = 1 To mPoints.Count
        
            TempArr(I - 1) = mPoints.Item(I).X
        
        Next I
        
        'Find minimum values of X coordinate of shape
        mvarMaximumX = Val(Find_Max_In_Array(TempArr()))
        
        AlreadyMaxX = True
        
    End If
    MaximumX = mvarMaximumX

End Property

Public Property Get MinimumZ() As Double
'Return Minimum value of Z coordinate of shape

    'Declarations
    Dim I As Long, TempArr() As Double
    
    If AlreadyMinZ = False Then
    
        AlreadyZCenter = False
        
        ReDim TempArr(mPoints.Count - 1)
        
        For I = 1 To mPoints.Count
        
            TempArr(I - 1) = mPoints.Item(I).Z
        
        Next I
        
        'Find minimum values of X coordinate of shape
        mvarMinimumZ = Val(Find_Min_In_Array(TempArr()))
        
        AlreadyMinZ = True
        
    End If
    MinimumZ = mvarMinimumZ

End Property

Public Property Get MinimumY() As Double
'Return Minimum value of Y coordinate of shape

    'Declarations
    Dim I As Long, TempArr() As Double
    
    If AlreadyMinY = False Then
    
        AlreadyYCenter = False
        
        ReDim TempArr(mPoints.Count - 1)
        
        For I = 1 To mPoints.Count
        
            TempArr(I - 1) = mPoints.Item(I).Y
        
        Next I
        
        'Find minimum values of X coordinate of shape
        mvarMinimumY = Val(Find_Min_In_Array(TempArr()))
                            
        AlreadyMinY = True
        
    End If
    MinimumY = mvarMinimumY

End Property

Public Property Get MinimumX() As Double
'Return Minimum value of X coordinate of shape

    'Declarations
    Dim I As Long, TempArr() As Double
    
    If AlreadyMinX = False Then
    
        AlreadyXCenter = False
        
        ReDim TempArr(mPoints.Count - 1)
        
        For I = 1 To mPoints.Count
        
            TempArr(I - 1) = mPoints.Item(I).X
        
        Next I
        
        'Find minimum values of X coordinate of shape
        mvarMinimumX = Val(Find_Min_In_Array(TempArr()))
                        
        AlreadyMinX = True
        
    End If
    MinimumX = mvarMinimumX

End Property

Public Property Get NewEnum() As IUnknown
    'Questa propriet consente di enumerare l'insieme
    'corrente con la sintassi For...Each.
    Set NewEnum = mPoints.[_NewEnum]
End Property

Public Property Get Point(vntIndexKey As Variant) As InBlu_Point_3D
'Return a reference to a point in the shape

    Set Point = mPoints.Item(vntIndexKey)
    
End Property

Public Property Get PointsNumber() As Long
'Return number of points in the shape
    
    PointsNumber = mPoints.Count
    
End Property

Public Property Let Selected(ByVal vData As Boolean)
'Set if a shape is selected
    
    'Declarations
    Dim I As Long
    
    mbooSelected = vData
    
    For I = 1 To mPoints.Count
        
        mPoints.Item(I).Selected = vData
        
    Next I

End Property

Public Property Get Selected() As Boolean
'Return if a shape is selected
    
    Selected = mbooSelected

End Property

Public Property Let Visible(ByVal vData As Boolean)
'Set if a shape is visible to the user or not
    
    mbooVisible = vData

End Property

Public Property Get Visible() As Boolean
'Return if a shape is visible to the user or not
    
    Visible = mbooVisible

End Property


'------------------------------------------------------------------------
'Methods
'------------------------------------------------------------------------

Public Function InfoSerializer(InfoToSerialize As String) As String
'This function is used to serialize in a string the infomation of the class

    Dim TmpSerializedInfo As String
    
    Select Case InfoToSerialize
    
'        Case "Coordinate"
'
'            TmpSerializedInfo = CStr(mdblX) & ";" & CStr(mdblY) & ";" & CStr(mdblZ) & ";" & CStr(miagOrientation.First) & ";" & CStr(miagOrientation.Second) & ";" & CStr(miagOrientation.Third) & ";"
'
'        Case "Offset"
'
'            TmpSerializedInfo = CStr(mdblX) & ";" & CStr(mdblY) & ";" & CStr(mdblZ) & ";" & CStr(miagOffsetOrientation.First) & ";" & CStr(miagOffsetOrientation.Second) & ";" & CStr(miagOffsetOrientation.Third) & ";"
'
        Case "PointsNumber"

            TmpSerializedInfo = Str(mPoints.Count) & " ;"
'
'        Case "Tool"
'
'            TmpSerializedInfo = CStr(mlngToolNumber)
'
'        Case "Procedure"
'
'            TmpSerializedInfo = CStr(mlngProcedure)
'
'        Case "OpenDelay"
'
'            TmpSerializedInfo = CStr(mdblOpenDelay)
'
'        Case "CloseDelay"
'
'            TmpSerializedInfo = CStr(mdblCloseDelay)
'
'        Case "Speed"
'
'            TmpSerializedInfo = CStr(mlngMarkerColour)
'
'        Case "ALL"
'            TmpSerializedInfo = CStr(mdblX) & ";" & CStr(mdblY) & ";" & CStr(mdblZ) & ";" & CStr(miagOrientation.First) & ";" & CStr(miagOrientation.Second) & ";" & CStr(miagOrientation.Third) & ";" _
'            & ";" & CStr(mdblX) & ";" & CStr(mdblY) & ";" & CStr(mdblZ) & ";" & CStr(miagOffsetOrientation.First) & ";" & CStr(miagOffsetOrientation.Second) & ";" & CStr(miagOffsetOrientation.Third) & ";" _
'            & ";" & CStr(mlngToolDistance) & ";" & CStr(mlngToolNumber) & ";" & CStr(mlngProcedure) & ";" & CStr(mdblOpenDelay) & ";" & CStr(mdblOpenDelay) & ";" & CStr(mdblCloseDelay) & ";" & _
'            CStr(mlngMarkerColour)
            
    End Select
    
    InfoSerializer = TmpSerializedInfo

End Function

Public Function AddPoint(NewMember As InBlu_Point_3D, Optional lKey As Long)
'Function to add a point to the shape
'INPUT PARAMETER:
'               NewMember:New point added to the shape
'               Lkey:Number to indicate the position of point in the shape
  
    
'    If mlngMarkerColour <> 0 Then
'
'        NewMember.MarkerColour = mlngMarkerColour
'
'    End If
    
    If lKey < 1 Then
    
        'Add a point after last position
        mPoints.Add NewMember
        
    Else
    
        If mPoints.Count <> 0 Then
       
            'Add new point in the specified position
            mPoints.Add NewMember, , lKey
            
        Else
        
            'Add first point
            mPoints.Add NewMember
        
        End If
        
    End If
        
    'Set to false all computation flag
    AlreadyInterpolated = False
    AlreadyLined = False
    AlreadyMaxX = False
    AlreadyMaxY = False
    AlreadyMaxZ = False
    AlreadyMinX = False
    AlreadyMinY = False
    AlreadyMinZ = False
    AlreadyXCenter = False
    AlreadyYCenter = False
    AlreadyZCenter = False
    
End Function

Public Sub RemovePoint(Optional lKey As Long)
'Function to remove one point from the shape
'INPUT PARAMETER:
'               lKey:Index of point to remove
    
    If mPoints.Count > 0 Then
    
        If lKey > 0 Then
        
            'Remove point from collection
            mPoints.Remove lKey
        
        Else
        
            mPoints.Remove mPoints.Count
            
        End If
        
    End If
    'Set to false all computation flag
    AlreadyInterpolated = False
    AlreadyLined = False
    AlreadyMaxX = False
    AlreadyMaxY = False
    AlreadyMaxZ = False
    AlreadyMinX = False
    AlreadyMinY = False
    AlreadyMinZ = False
    AlreadyXCenter = False
    AlreadyYCenter = False
    AlreadyZCenter = False
    
End Sub

Public Sub Rotate(Transformation() As Double, Optional ByVal XCntr = "Vuoto", _
                Optional ByVal YCntr = "Vuoto", Optional ByVal ZCntr = "Vuoto")
                
'Function to rotate a shape around a center
'INPUT PARAMETER:
'               Transformation():Matrix of rotation
'               XCntr: X coordinate of center rotation
'               YCntr: Y coordinate of center rotation
'               ZCntr: Z coordinate of center rotation

    'Declarations
    Dim I As Long
    
    'Check if a center rotation point is specified
    If XCntr = "Vuoto" Or YCntr = "Vuoto" Or ZCntr = "Vuoto" Then
    
        'Set center rotation center of shape
        RotXCenter = Xcenter
        RotYCenter = YCenter
        RotZCenter = ZCenter
        
    Else
    
        'Set a user's center rotation
        RotXCenter = Val(XCntr)
        RotYCenter = Val(YCntr)
        RotZCenter = Val(ZCntr)
        
    End If
    
    For I = 1 To mPoints.Count
        
        'Call rotate method for each points
        mPoints.Item(I).Rotate Me, Transformation()
        
    Next I
    
    'Set to false all computation flag
    AlreadyInterpolated = False
    AlreadyLined = False
    AlreadyMaxX = False
    AlreadyMaxY = False
    AlreadyMaxZ = False
    AlreadyMinX = False
    AlreadyMinY = False
    AlreadyMinZ = False
    AlreadyXCenter = False
    AlreadyYCenter = False
    AlreadyZCenter = False

End Sub

Public Sub MoveDelta(ByVal DeltaX As Double, ByVal DeltaY As Double, ByVal DeltaZ As Double)

    'Declarations
    Dim I As Long
    
    For I = 1 To PointsNumber
    
        mPoints.Item(I).MoveDelta DeltaX, DeltaY, DeltaZ

    Next I

End Sub

Public Function Pointers() As Long()
'Return an array with pointers that
'keeps trace of colour changing in the
'shape
'OUTPUT PARAMETER:
'               Pointers():Return the array pointers
    
'    Select Case mstrRappresentationMode
'
'        Case Style.Spline, Style.SplineAndMarker
            
            Pointers = ArraySplinesPointers()
            
'        Case Else
'
'            Pointers = ArrayLinesPointers()
'
'    End Select

End Function

Public Function Markers() As String()
'Return an array with markers of original
'points in the shape
'OUTPUT PARAMETER:
'               Markers():Return the array markers

'    Select Case mstrRappresentationMode
'
'        Case Style.Spline, Style.SplineAndMarker
            
            Markers = ArraySplinesMarkers()
                    
'        Case Else
'
'            Markers = ArrayLinesMarkers()
'
'    End Select

End Function

Public Function MarkersSize() As Long()
'Return an array with markers of original
'points in the shape
'OUTPUT PARAMETER:
'               Markers():Return the array markers

'    Select Case mstrRappresentationMode
'
'        Case Style.Spline, Style.SplineAndMarker
            
            MarkersSize = ArraySplinesMarkersSize()
                    
'        Case Else
'
'            MarkersSize = ArrayLinesMarkersSize()
'
'    End Select

End Function

Public Function XCoordinates() As Double()
'Return an array with X coordinates of
'points in the shape
'OUTPUT PARAMETER:
'               XCoordinate():Return the array coordinates

'    Select Case mstrRappresentationMode
'
'        Case Style.Spline, Style.SplineAndMarker
            
            If PrevXAngle = 0 And PrevYAngle = 0 And PrevXSAngle = 0 Then
                
                XCoordinates = CoordinateOutOfPlane.X()
            
            ElseIf PrevXAngle = 0 And PrevYAngle = 90 And PrevXSAngle = 90 Then
                
                XCoordinates = CoordinateOutOfPlane.Z()
                
            ElseIf PrevXAngle = 0 And PrevYAngle = 90 And PrevXSAngle = 0 Then
                
                XCoordinates = CoordinateOutOfPlane.Y()
            
            End If
                        
'        Case Else
'
'            XCoordinates = ArrayLines.X()
                
'    End Select
   
End Function


Public Function YCoordinates() As Double()
'Return an array with Y coordinates of
'points in the shape
'OUTPUT PARAMETER:
'               YCoordinate():Return the array coordinates

'    Select Case mstrRappresentationMode
'
'        Case Style.Spline, Style.SplineAndMarker
        
            YCoordinates = ArraySplines.Y()
            
'        Case Else
'
'            YCoordinates = ArrayLines.Y()
'
'    End Select
    
End Function


Public Function ZCoordinates() As Double()
'Return an array with Z coordinates of
'points in the shape
'OUTPUT PARAMETER:
'               ZCoordinate():Return the array coordinates

'    Select Case mstrRappresentationMode
'
'        Case Style.Spline, Style.SplineAndMarker
            
            ZCoordinates = ArraySplines.Z()
            
'        Case Else
'
'            ZCoordinates = ArrayLines.Z()
'
'    End Select
    
End Function


Public Function Colours() As Long()
'Return an array with colours of original
'points in the shape
'OUTPUT PARAMETER:
'               Colours():Return the array colours
    
'    Select Case mstrRappresentationMode
'
'        Case Style.Spline, Style.SplineAndMarker
            
            Colours = ArraySplinesColour()
            
'        Case Else
'
'            Colours = ArrayLinesColour()
'
'    End Select
    
End Function

Public Sub CopyProperties(Destination As InBlu_Shape_3D)
'Function to copy the properties
'of point in an other point
'INPUT\OUTPUT PARAMETER:
'                       Destination:Point where store the properties

    'Declarations
    Dim I As Long
    Dim tmpPoint As InBlu_Point_3D
    
'    Destination.MarkerColour = mlngMarkerColour
    
    With Destination
    
    For I = 1 To mPoints.Count
    
        Set tmpPoint = New InBlu_Point_3D
        
        Destination.AddPoint tmpPoint
       
        mPoints.Item(I).CopyProperties .Point(I)
        .Point(I).BaseX = mPoints.Item(I).BaseX
        .Point(I).BaseY = mPoints.Item(I).BaseY
        .Point(I).BaseZ = mPoints.Item(I).BaseZ
        .Point(I).X = mPoints.Item(I).X
        .Point(I).Y = mPoints.Item(I).Y
        .Point(I).Z = mPoints.Item(I).Z
        .Point(I).OffsetX = mPoints.Item(I).OffsetX
        .Point(I).OffsetY = mPoints.Item(I).OffsetY
        .Point(I).OffsetZ = mPoints.Item(I).OffsetZ
        .Point(I).OffsetOrientation.First = mPoints.Item(I).OffsetOrientation.First
        .Point(I).OffsetOrientation.Second = mPoints.Item(I).OffsetOrientation.Second
        .Point(I).OffsetOrientation.Third = mPoints.Item(I).OffsetOrientation.Third
        .Point(I).Orientation.First = mPoints.Item(I).Orientation.First
        .Point(I).Orientation.Second = mPoints.Item(I).Orientation.Second
        .Point(I).Orientation.Third = mPoints.Item(I).Orientation.Third

        Set tmpPoint = Nothing
        
    Next I
    
        .Selected = mbooSelected
        .Visible = mbooVisible
        .LineWidth = mlngLineWidth
        .LineColour = mlngLineColour
        .LineStyle = mlngLineStyle
        .RappresentationMode = mstyRappresentationMode
        .NumberInterpolatedPoints = mlngNumberInterpolatedPoints
        .Closed = mbooClosed
        .Identification = mwtyIdentification
        
    End With
    
    
End Sub

Public Sub Draw(ByVal Context As Object)
'Function to draw the shape on video
'INPUT PARAMETER:
'               Context: Where draw the shape
    
    'Declarations
    Dim I As Long, K As Long, Y As Long
    Dim Temporary() As P_Type_3D, TempSpline() As P_Type_3D
    Dim Counter As Long, FindPoint As Boolean
    Dim Colour As Long, PrevColour As Long
    Dim CosAlpha As Double, CosBeta As Double, CosGamma As Double
    Dim SinAlpha As Double, SinBeta As Double, SinGamma As Double
    Dim Alpha As Double, Beta As Double
    Dim Xc As Double, Yc As Double, Zc As Double
    Dim Offset As Long, Temp As Double 'Test
    Dim Calculator As New Inblu_Geom_Calculator
    Dim RZ(1 To 4, 1 To 4) As Double
    Dim RY(1 To 4, 1 To 4) As Double
    Dim RSY(1 To 4, 1 To 4) As Double
    Dim Trans() As Double
    Dim Trans1() As Double
    Dim MRes() As Double
    Dim Vect(1 To 4, 1) As Double
    
    'Find if there are some changing in the spin angles
    If Context.SpinScreenXAngle <> PrevXAngle Or Context.SpinScreenYAngle <> PrevYAngle _
         Or Context.SpinScreenXSAngle <> PrevXSAngle Then

        AlreadyInterpolated = False
        AlreadyLined = False
        PrevXAngle = Context.SpinScreenXAngle
        PrevYAngle = Context.SpinScreenYAngle
        PrevXSAngle = Context.SpinScreenXSAngle

    End If

    mlngPointsNumber = mPoints.Count
    '****************************************************
    'ATTENTION: Angle for Cos and Sin function
    'must to be expressed in Radiant.In our case
    'the user put an angle in degrees and then
    'is converted in radiant by formule :Angle*(PiGreco/180)
    '****************************************************
    Alpha = Context.SpinScreenYAngle * (PiGreco / 180)
    Beta = Context.SpinScreenXAngle * (PiGreco / 180)
    
    CosAlpha = Cos(Alpha)
    SinAlpha = Sin(Alpha)
    CosBeta = Cos(Beta)
    SinBeta = Sin(Beta)
    
    Xc = Context.Xcenter
    Yc = Context.YCenter
    Zc = Context.ZCenter
    
    Calculator.RotY Context.SpinScreenXAngle, RY()
    Calculator.RotZ Context.SpinScreenYAngle, RZ()
    Calculator.RotY Context.SpinScreenXSAngle, RSY()
    
    If mlngPointsNumber < 2 Then
        mstyRappresentationMode = Style.Marker
    End If
    'Choose how to rappresent the shape
    If mstyRappresentationMode <> Style.Marker Then ' Or mstrRappresentationMode = Style.SplineAndMarker Then
        'Draw Interpolated Points
            'Check if spline is already calculate or need
            'another computation
            'If AlreadyInterpolated = False Then
            
                'Set all array used to draw
                ReDim CoordinateOutOfPlane.X(mlngNumberInterpolatedPoints - 1)
                ReDim CoordinateOutOfPlane.Y(mlngNumberInterpolatedPoints - 1)
                ReDim CoordinateOutOfPlane.Z(mlngNumberInterpolatedPoints - 1)
                ReDim Temporary(mlngPointsNumber - 1)
                ReDim TempSpline(mlngNumberInterpolatedPoints - 1)
                ReDim ArraySplinesColour(mlngPointsNumber - 1)
                ReDim ArraySplinesMarkers(mlngPointsNumber - 1)
                ReDim ArraySplinesMarkersSize(mlngPointsNumber - 1)
                ReDim ArraySplines.X(mlngNumberInterpolatedPoints - 1)
                ReDim ArraySplines.Y(mlngNumberInterpolatedPoints - 1)
                ReDim ArraySplines.Z(mlngNumberInterpolatedPoints - 1)
                ReDim ArraySplinesPointers(mlngPointsNumber - 1)
                
                'Translate the array in the right format for
                'C_Spline function
                For I = 1 To mlngPointsNumber
                    Temporary(I - 1).X = mPoints.Item(I).BaseX + mPoints.Item(I).OffsetX
                    Temporary(I - 1).Y = mPoints.Item(I).BaseY + mPoints.Item(I).OffsetY
                    Temporary(I - 1).Z = mPoints.Item(I).BaseZ + mPoints.Item(I).OffsetZ
                    ArraySplinesColour(I - 1) = mPoints.Item(I).MarkerColour
                Next I
                If mlngPointsNumber = 2 Or mstyRappresentationMode = Style.MarkerAndLines Or mstyRappresentationMode = Style.Lines Then
                    If mbooClosed Then
                     InterpolateLinear3D4S Temporary(), TempSpline()
                    Else
                     InterpolateLinear3D Temporary(), TempSpline()
                    End If
                Else
                    If mbooClosed Then
                        'Fuction to calculate C-Spline
                        C_Spline_3D4S Temporary(), TempSpline()
                    Else
                        'Fuction to calculate C-Spline
                        C_Spline_3D Temporary(), TempSpline()
                    End If
                End If
                
                'Translate the array of interpolated points
                'in an other format.This operation is necessary
                'cause the API function used to draw needs an
                'extra point to complete the pattern in the right
                'way (See ActiveX module in Option Explicit)
                For I = 0 To mlngNumberInterpolatedPoints - 1
                    CoordinateOutOfPlane.X(I) = TempSpline(I).X
                    CoordinateOutOfPlane.Y(I) = TempSpline(I).Y
                    CoordinateOutOfPlane.Z(I) = TempSpline(I).Z
                Next I

                'Apply eventually rotation
                For I = 0 To mlngPointsNumber - 1
                    Vect(1, 1) = Temporary(I).X - Xc
                    Vect(2, 1) = Temporary(I).Y - Yc
                    Vect(3, 1) = Temporary(I).Z - Zc
                    Vect(4, 1) = 1

                    Trans = MMol(RZ(), RY())
                    Trans1 = MMol(RSY(), Trans())
                    MRes = MMol(Trans1(), Vect())

                    Temporary(I).X = MRes(1, 1) + Xc
                    Temporary(I).Y = MRes(2, 1) + Yc
                    Temporary(I).Z = MRes(3, 1) + Zc
                Next I

                If mlngPointsNumber = 2 Or mstyRappresentationMode = Style.MarkerAndLines Or mstyRappresentationMode = Style.Lines Then
                    If mbooClosed Then
                     InterpolateLinear3D4S Temporary(), TempSpline()
                    Else
                     InterpolateLinear3D Temporary(), TempSpline()
                    End If
                Else
                    If mbooClosed Then
                        'Fuction to calculate C-Spline
                        C_Spline_3D4S Temporary(), TempSpline()
                    Else
                        'Fuction to calculate C-Spline
                        C_Spline_3D Temporary(), TempSpline()
                    End If
                End If
                                        
                'Translate the array of interpolated points
                'in an other format.This operation is necessary
                'cause the API function used to draw needs an
                'extra point to complete the pattern in the right
                'way (See ActiveX module in Option Explicit)
                For I = 0 To mlngNumberInterpolatedPoints - 1
      
                    ArraySplines.X(I) = TempSpline(I).X
                    ArraySplines.Y(I) = TempSpline(I).Y
                    ArraySplines.Z(I) = TempSpline(I).Z
                    
                Next I
                
                'Pointer Colour to first point
                ArraySplinesPointers(0) = 0
                
                If mPoints.Item(1).Selected Then
                
                    ArraySplinesMarkers(0) = "Selected"
                
                Else
                    
                    ArraySplinesMarkers(0) = mPoints.Item(1).MarkerStyle
                    
                End If
                
                ArraySplinesMarkersSize(0) = mPoints.Item(1).MarkerSize
                

                If mPoints.Item(mlngPointsNumber).Selected Then
                
                    ArraySplinesMarkers(mlngPointsNumber - 1) = "Selected"
                
                Else
                
                    'Markers of last two points
                    ArraySplinesMarkers(mlngPointsNumber - 1) = mPoints.Item(mlngPointsNumber).MarkerStyle
       
                End If
                
                'Define the colour for any interpolated point
                'Colour of points is take from next original point
                'until the original point is reached.
                For K = 2 To mlngPointsNumber
                
                    If mPoints.Item(K).Selected Then
                    
                        ArraySplinesMarkers(K - 1) = "Selected"
                    
                    Else
                    
                        ArraySplinesMarkers(K - 1) = mPoints.Item(K).MarkerStyle
                    
                    End If
                    
                    ArraySplinesMarkersSize(K - 1) = mPoints.Item(K).MarkerSize
                    
                    Do
                        
                        'Check where is original point in the interpolated array
                           
                        If Temporary(K - 1).X = ArraySplines.X(Counter) And _
                            Temporary(K - 1).Y = ArraySplines.Y(Counter) And _
                            Temporary(K - 1).Z = ArraySplines.Z(Counter) Then
                            
                            'Point has been found
                            FindPoint = True
                            ArraySplinesPointers(K - 1) = Counter
                            
                        End If
                        
                        Counter = Counter + 1
                    
                    Loop Until FindPoint
                    
                    'Reset
                    FindPoint = False
                    
                Next K
               
                AlreadyInterpolated = True
                        
            'End If
                        
'        Else
'
'            MsgBox "Per ora non posso interpolare due punti", vbInformation, "System Communication"
'
'        End If
    
    Else
    
        'Draw Lines and Markers
        
'        If AlreadyLined = False Then
            
            'Set the dimension of all array used to draw
            ReDim ArraySplines.X(mlngPointsNumber - 1)
            ReDim ArraySplines.Y(mlngPointsNumber - 1)
            ReDim ArraySplines.Z(mlngPointsNumber - 1)
            ReDim ArraySplinesColour(mlngPointsNumber - 1)
            ReDim ArraySplinesPointers(mlngPointsNumber - 1)
            ReDim ArraySplinesMarkers(mlngPointsNumber - 1)
            ReDim ArraySplinesMarkersSize(mlngPointsNumber - 1)

            'Set values in the arrays
            For I = 1 To mlngPointsNumber

                ArraySplines.X(I - 1) = mPoints.Item(I).X
                ArraySplines.Y(I - 1) = mPoints.Item(I).Y
                ArraySplines.Z(I - 1) = mPoints.Item(I).Z
                ArraySplinesColour(I - 1) = mPoints.Item(I).MarkerColour
                ArraySplinesPointers(I - 1) = I - 1
                If mPoints.Item(I).Selected Then

                    ArraySplinesMarkers(I - 1) = "Selected"

                Else

                    ArraySplinesMarkers(I - 1) = mPoints.Item(I).MarkerStyle

                End If

                ArraySplinesMarkersSize(I - 1) = mPoints.Item(I).MarkerSize

            Next I

            For I = 0 To mlngPointsNumber - 1

                Vect(1, 1) = ArraySplines.X(I) - Xc
                Vect(2, 1) = ArraySplines.Y(I) - Yc
                Vect(3, 1) = ArraySplines.Z(I) - Zc
                Vect(4, 1) = 1

                Trans = MMol(RZ(), RY())
                Trans1 = MMol(RSY(), Trans())

                MRes = MMol(Trans1(), Vect())

                ArraySplines.X(I) = MRes(1, 1) + Xc
                ArraySplines.Y(I) = MRes(2, 1) + Yc
                ArraySplines.Z(I) = MRes(3, 1) + Zc


            Next I

'        End If
'
'        AlreadyLined = True
'
    End If
    
End Sub

Public Sub GetNearestPoint(ByVal X As Double, Y As Double, ByVal Plane As PlaneType, Index As Long, _
                            Dist As Double)

    'Declarations
    Dim Delta1 As Double, Delta2 As Double
    Dim PrevMinDist As Double, I As Long
    
    Select Case Plane
    
        Case PlaneType.xy
        
            For I = 1 To PointsNumber
                
                'Find the distance between original points and point
                'passed
                Delta1 = Abs(X - mPoints.Item(I).X)
                Delta2 = Abs(Y - mPoints.Item(I).Y)
                
                If I = 1 Then
                
                    'Distance calculated with Pitagora's theorem
                    Dist = Sqr(Delta1 ^ 2 + Delta2 ^ 2)
                    PrevMinDist = Dist
                    Index = 1
                
                Else
                
                    PrevMinDist = Quick_Find_Min(PrevMinDist, Sqr(Delta1 ^ 2 + Delta2 ^ 2))
                    
                    If PrevMinDist <> Dist Then
                    
                        Index = I
                        Dist = PrevMinDist
                        
                    End If
                                   
                End If
        
            Next I
                
        Case PlaneType.xz
        
            For I = 1 To PointsNumber
                
                'Find the distance between original points and point
                'passed
                Delta1 = Abs(X - mPoints.Item(I).X)
                Delta2 = Abs(Y - mPoints.Item(I).Z)
                
                If I = 1 Then
                
                    'Distance calculated with Pitagora's theorem
                    Dist = Sqr(Delta1 ^ 2 + Delta2 ^ 2)
                    PrevMinDist = Dist
                    Index = 1
                
                Else
                
                    PrevMinDist = Quick_Find_Min(PrevMinDist, Sqr(Delta1 ^ 2 + Delta2 ^ 2))
                    
                    If PrevMinDist <> Dist Then
                    
                        Index = I
                        Dist = PrevMinDist
                        
                    End If
                                   
                End If
        
            Next I
                

        Case PlaneType.yz
        
            For I = 1 To PointsNumber
                
                'Find the distance between original points and point
                'passed
                Delta1 = Abs(X - mPoints.Item(I).Y)
                Delta2 = Abs(Y - mPoints.Item(I).Z)
                
                If I = 1 Then
                
                    'Distance calculated with Pitagora's theorem
                    Dist = Sqr(Delta1 ^ 2 + Delta2 ^ 2)
                    PrevMinDist = Dist
                    Index = 1
                
                Else
                
                    PrevMinDist = Quick_Find_Min(PrevMinDist, Sqr(Delta1 ^ 2 + Delta2 ^ 2))
                    
                    If PrevMinDist <> Dist Then
                    
                        Index = I
                        Dist = PrevMinDist
                        
                    End If
                                   
                End If
        
            Next I
                
    End Select

End Sub

'------------------------------------------------------------------------
'Events
'------------------------------------------------------------------------

Private Sub Class_Initialize()
    
    'Set a collection when the class is created
    Set mPoints = New Collection
    
    'Initialize properties
    mlngMarkerColour = vbRed
    mlngMarkerSize = 3
    mstrMarkerStyle = "o"
    mbooVisible = True
    mlngLineStyle = vbSolid
    mlngLineWidth = 1
    mlngLineColour = vbBlue
    mbooSelected = False
    mstyRappresentationMode = Style.Marker
    mlngNumberInterpolatedPoints = 500
    mbooClosed = False
    mwtyIdentification = Graphical
    mstrProcedure = ""
    mbooMoveable = True
    
End Sub


Private Sub Class_Terminate()
    
    'Remove the collection when the class is destroyed
    Set mPoints = Nothing
    
End Sub

