VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "InBlu_Solid"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'==================================================================================================================
' Description.....: Interface module to manage a solid to rappresent on video
' File Name.......: InBlu_Solid.cls
' Data............: 04/12/2003
' Version.........: 1.0(32 bit).
' System..........: VB6,Windows 98.
' Written by......: Condor trade s.r.l.
' E-Mail..........: info@condorgroup.com
' web Site........: http://www.inblu.com
'==================================================================================================================

Option Explicit

'Collection of shapes
Private mShapes As Collection

Private AlreadyCentered As Boolean
'Flag that indicate if a shape is already interpolated
Private AlreadyInterpolated As Boolean
'Flag that indicate if a shape is already been drawn
Private AlreadyLined As Boolean
'Flag that indicate if for the shape is already calculate MinX value
Private AlreadyMinX As Boolean
'Flag that indicate if for the shape is already calculate MinY value
Private AlreadyMinY As Boolean
'Flag that indicate if for the shape is already calculate MinZ value
Private AlreadyMinZ As Boolean
'Flag that indicate if for the shape is already calculate MaxX value
Private AlreadyMaxX As Boolean
'Flag that indicate if for the shape is already calculate MaxY value
Private AlreadyMaxY As Boolean
'Flag that indicate if for the shape is already calculate MaxZ value
Private AlreadyMaxZ As Boolean
'Flag that indicate if for the shape is already calculate XCenter value
Private AlreadyXCenter As Boolean
'Flag that indicate if for the shape is already calculate YCenter value
Private AlreadyYCenter As Boolean
'Flag that indicate if for the shape is already calculate ZCenter value
Private AlreadyZCenter As Boolean
'Flag taht indicate if for the solid is already specified XCenter for rotation
Private RotXCSetted As Boolean
'Flag taht indicate if for the solid is already specified YCenter for rotation
Private RotYCSetted As Boolean
'Flag taht indicate if for the solid is already specified ZCenter for rotation
Private RotZCSetted As Boolean

'Properties local variables:

'Local copy of Selected property
Private mbooSelected As Boolean
'Local copy of Selected property
Private mbooClosed As Boolean
'Local copy of MinimumX property
Private mvarMinimumX As Double
'Local copy of MinimumY property
Private mvarMinimumY As Double
'Local copy of MinimumZ property
Private mvarMinimumZ As Double
'Local copy of MaximumX property
Private mvarMaximumX As Double
'Local copy of MaximumY property
Private mvarMaximumY As Double
'Local copy of MaximumZ property
Private mvarMaximumZ As Double
'Local copy of Visible property
Private mbooVisible As Boolean
'Local copy of XCenter Property
Private mvarXCenter As Double
'Local copy of YCenter Property
Private mvarYCenter As Double
'Local copy of ZCenter Property
Private mvarZCenter As Double
'Local copy of RotXCenter property
Private mdblRotXCenter As Double
'Local copy of RotYCenter property
Private mdblRotYCenter As Double
'Local copy of RotZCenter property
Private mdblRotZCenter As Double
'Local copy of Saved property
Private mbooSaved As Boolean
'Local copy of Saveable property
Private mbooSaveable As Boolean
'Local copy of Moveable property
Private mbooMoveable As Boolean

'------------------------------------------------------------------------
'Properties
'------------------------------------------------------------------------

Public Property Get Moveable() As Boolean
'Return if a solid is Moveable

    Moveable = mbooMoveable
    
End Property

Public Property Let Moveable(ByVal NewValue As Boolean)
'Set if a solid is Moveable

    'Declarations
    Dim I As Long
    
    mbooMoveable = NewValue
    
    For I = 1 To mShapes.Count
    
        mShapes.Item(I).Moveable = mbooMoveable
    
    Next I
    
End Property

Public Property Get Closed() As Boolean
'Return if a solid is closed

    Closed = mbooClosed
    
End Property

Public Property Let Closed(ByVal NewValue As Boolean)
'Set if a solid is closed

    'Declarations
    Dim I As Long
    
    mbooClosed = NewValue
    
    For I = 1 To ShapesNumber
    
        mShapes.Item(I).Closed = mbooClosed
    
    Next I

End Property

Public Property Get Saved() As Boolean
'Indicate if solid is already saved
    
    Saved = mbooSaved

End Property

Public Property Let Saved(ByVal vNewValue As Boolean)
'Indicate if solid is already saved

    mbooSaved = vNewValue

End Property

Public Property Get Saveable() As Boolean
'Indicate if solid is already saved
    
    Saveable = mbooSaveable

End Property

Public Property Let Saveable(ByVal vNewValue As Boolean)
'Indicate if solid is already saved

    mbooSaveable = vNewValue

End Property

Public Property Get RotZCenter() As Double
'Return the value of Z coordinate center
    
    RotZCenter = mdblRotZCenter
    
End Property

Public Property Let RotZCenter(vData As Double)
'Return the value of Z coordinate center
    
    RotZCSetted = True
    mdblRotZCenter = vData
    
End Property

Public Property Get RotYCenter() As Double
'Return the value of Y coordinate center
    
    RotYCenter = mdblRotYCenter

End Property

Public Property Let RotYCenter(vData As Double)
'Return the value of Z coordinate center
    
    RotYCSetted = True
    mdblRotYCenter = vData
    
End Property

Public Property Get RotXCenter() As Double
'Return the value of X coordinate center
    
    RotXCenter = mdblRotXCenter

End Property

Public Property Let RotXCenter(vData As Double)
'Return the value of X coordinate center
    
    RotXCSetted = True
    mdblRotXCenter = vData
    
End Property

Public Property Get ZCenter() As Double
'Return the value of Z coordinate center
    
    mvarZCenter = Val(Find_Center(MinimumZ, MaximumZ))
    
    ZCenter = mvarZCenter
    
End Property

Public Property Get YCenter() As Double
'Return the value of Y coordinate center
    
    mvarYCenter = Val(Find_Center(MinimumY, MaximumY))
    
    YCenter = mvarYCenter

End Property

Public Property Get Xcenter() As Double
'Return the value of X coordinate center
    
    mvarXCenter = Val(Find_Center(MinimumX, MaximumX))
    
    Xcenter = mvarXCenter

End Property


Public Property Get MaximumZ() As Double
'Return Maximum value of Z coordinate of solid
    
    'Declarations
    Dim I As Long
    
        'AlreadyZCenter = False
        
        mvarMaximumZ = mShapes.Item(1).MaximumZ
        
        If ShapesNumber > 1 Then
        
            For I = 2 To ShapesNumber
        
                If mShapes.Item(I).MaximumZ < mvarMaximumZ Then mvarMaximumZ = mShapes.Item(I).MaximumZ
            
            Next I

        End If

        AlreadyMaxZ = True
        
    MaximumZ = mvarMaximumZ

End Property

Public Property Get MaximumY() As Double
'Return Maximum value of Y coordinate of solid
    
    'Declarations
    Dim I As Long
    
        'AlreadyYCenter = False
        
        mvarMaximumY = mShapes.Item(1).MaximumY
        
        If ShapesNumber > 1 Then
        
            For I = 2 To ShapesNumber
        
                If mShapes.Item(I).MaximumY < mvarMaximumY Then mvarMaximumY = mShapes.Item(I).MaximumY
            
            Next I

        End If

    MaximumY = mvarMaximumY

End Property

Public Property Get MaximumX() As Double
'Return Maximum value of X coordinate of solid
    
    'Declarations
    Dim I As Long
    
        'AlreadyXCenter = False
        
        mvarMaximumX = mShapes.Item(1).MaximumX
        
        If ShapesNumber > 1 Then
        
            For I = 2 To ShapesNumber
        
                If mShapes.Item(I).MaximumX < mvarMaximumX Then mvarMaximumX = mShapes.Item(I).MaximumX
            
            Next I

        End If

    MaximumX = mvarMaximumX

End Property

Public Property Get MinimumZ() As Double
'Return Minimum value of Z coordinate of solid

    'Declarations
    Dim I As Long
    
       'AlreadyZCenter = False
        
        mvarMinimumZ = mShapes.Item(1).MinimumZ
        
        If ShapesNumber > 1 Then
        
            For I = 2 To ShapesNumber
        
                If mShapes.Item(I).MinimumZ < mvarMinimumZ Then mvarMinimumZ = mShapes.Item(I).MinimumZ
            
            Next I

        End If
        
   MinimumZ = mvarMinimumZ

End Property

Public Property Get MinimumY() As Double
'Return Minimum value of Y coordinate of solid

    'Declarations
    Dim I As Long
    
       'AlreadyYCenter = False
        
        mvarMinimumY = mShapes.Item(1).MinimumY
        
        If ShapesNumber > 1 Then
        
            For I = 2 To ShapesNumber
        
                If mShapes.Item(I).MinimumY < mvarMinimumY Then mvarMinimumY = mShapes.Item(I).MinimumY
            
            Next I

        End If
        
    MinimumY = mvarMinimumY

End Property

Public Property Get MinimumX() As Double
'Return Minimum value of X coordinate of solid

    'Declarations
    Dim I As Long
    
    'AlreadyXCenter = False
        
    mvarMinimumX = mShapes.Item(1).MinimumX
        
    If ShapesNumber > 1 Then
        
        For I = 2 To ShapesNumber
        
            If mShapes.Item(I).MinimumX < mvarMinimumX Then mvarMinimumX = mShapes.Item(I).MinimumX
            
        Next I

    End If
        
    MinimumX = mvarMinimumX

End Property

Public Property Let Selected(ByVal vData As Boolean)
'Set if a solid is selected
    
    'Declarations
    Dim I As Long
    
    mbooSelected = vData
    
    For I = 1 To mShapes.Count
    
        mShapes.Item(I).Selected = vData
    
    Next I

End Property

Public Property Get Selected() As Boolean
'Return if a solid is selected
    
    Selected = mbooSelected

End Property

Public Property Let Visible(ByVal vData As Boolean)
'Set if a solid is visible to the user or not
    
    mbooVisible = vData

End Property

Public Property Get Visible() As Boolean
'Return if a solid is visible to the user or not
    
    Visible = mbooVisible

End Property

Public Property Get NewEnum() As IUnknown
    'Questa propriet consente di enumerare l'insieme
    'corrente con la sintassi For...Each.
    Set NewEnum = mShapes.[_NewEnum]
End Property

Public Property Get Shape(vntIndexKey As Variant) As InBlu_Shape_3D
'Return a reference to a point in the shape

    Set Shape = mShapes.Item(vntIndexKey)
    
End Property

Public Property Get ShapesNumber() As Long
'Return number of points in the shape
    
    ShapesNumber = mShapes.Count
    
End Property


'------------------------------------------------------------------------
'Methods
'------------------------------------------------------------------------
Public Sub MoveDelta(ByVal DeltaX As Double, ByVal DeltaY As Double, ByVal DeltaZ As Double)

    'Declarations
    Dim I As Long
    
    For I = 1 To mShapes.Count
    
        mShapes.Item(I).MoveDelta DeltaX, DeltaY, DeltaZ

    Next I

End Sub

Public Sub Rotate(Transformation() As Double)
'Function to rotate a solid around a center
'INPUT PARAMETER:
'               Context:Where to draw the solid

    'Declarations
    Dim I As Long
    Dim Xc As Double, Yc As Double, Zc As Double
    
    
    If RotXCSetted = False And RotYCSetted = False And RotZCSetted = False Then
    
        If AlreadyCentered = False Then
            
            RotXCenter = Xcenter
            RotYCenter = YCenter
            RotZCenter = ZCenter
        
            AlreadyCentered = True
            
        End If
        
    End If
    
    For I = 1 To mShapes.Count
        
        'Call rotate method for each points
        mShapes.Item(I).Rotate Transformation(), RotXCenter, RotYCenter, RotZCenter
        
    Next I
    
End Sub

Public Sub RemoveShape(Optional lKey As Long = 1)
'Function to remove one shape from the solid collection
'INPUT PARAMETER:
'               lKey:Index of shape to remove
            
    'Remove shape from the specified position of collection
    mShapes.Remove lKey
    
    'Set to false all computation flag
    'AlreadyInterpolated = False
    'AlreadyLined = False
    AlreadyMaxX = False
    AlreadyMaxY = False
    AlreadyMaxZ = False
    AlreadyMinX = False
    AlreadyMinY = False
    AlreadyMinZ = False
    AlreadyXCenter = False
    AlreadyYCenter = False
    AlreadyZCenter = False
    
End Sub

Public Function AddShape(NewMember As InBlu_Shape_3D, Optional lKey As Long = 1) As Variant
'Function to add a shape to the solid
'INPUT PARAMETER:
'               NewMember:New shape added to the solid
'               Lkey:Number to indicate the position of shape in the solid collection
  
            
    If lKey <= 1 Then
    
        'Add a shape after last shape
        mShapes.Add NewMember
        
    Else
    
        'Add new shape in the specified position
        mShapes.Add NewMember, , lKey
    
    End If
        
    'Set to false all computation flag
    'AlreadyInterpolated = False
    'AlreadyLined = False
    AlreadyMaxX = False
    AlreadyMaxY = False
    AlreadyMaxZ = False
    AlreadyMinX = False
    AlreadyMinY = False
    AlreadyMinZ = False
    AlreadyXCenter = False
    AlreadyYCenter = False
    AlreadyZCenter = False
    

End Function


'------------------------------------------------------------------------
'Events
'------------------------------------------------------------------------


Private Sub Class_Initialize()

    Set mShapes = New Collection
    
    'Initialize properties
    mbooSelected = False
    mbooClosed = False
    mbooVisible = True
    mbooSaved = False
    mbooMoveable = True
    
End Sub

Private Sub Class_Terminate()

    Set mShapes = Nothing

End Sub


