VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "InBlu_Translator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'==================================================================================================================
' Description.....: Interface module to manage different type of file for GSS program
' File Name.......: InBlu_Translate.cls
' Data............: 04/12/2003
' Version.........: 1.0(32 bit).
' System..........: VB6,Windows 98.
' Written by......: Condor trade s.r.l.
' E-Mail..........: info@condorgroup.com
' web Site........: http://www.inblu.com
'==================================================================================================================

Option Explicit

'Identification Constants
Private Const FILE_SOLIDINFO = "SOLID INFORMATIONS : "
Private Const FILE_SHAPEINFO = vbTab & "SHAPE INFORMATIONS : "
Private Const FILE_POINTINFO = vbTab & vbTab & "POINT INFORMATIONS : "
Private Const FILE_SOLIDLABEL = "SOLID "
Private Const FILE_SHAPELABEL = vbTab & "SHAPE "
Private Const FILE_POINTLABEL = vbTab & vbTab & "POINT "
Private Const FILE_N_SOLID = "SOLID NUMBER : "
Private Const FILE_N_SHAPE = vbTab & "SHAPE NUMBER : "
Private Const FILE_N_POINT = vbTab & vbTab & "POINT NUMBER : "
Private Const FILE_SEPARATOR = "******************************************"

'Shape Setting Constants
Private Const FILE_SHAPE_SET_MARKERCOLOUR = vbTab & "MARKERCOLOUR : "
Private Const FILE_SHAPE_SET_MARKERSIZE = vbTab & "MARKERSIZE : "
Private Const FILE_SHAPE_SET_MARKERSTYLE = vbTab & "MARKERSTYLE : "
Private Const FILE_SHAPE_SET_LINECOLOUR = vbTab & "LINECOLOUR : "
Private Const FILE_SHAPE_SET_LINESTYLE = vbTab & "LINESTYLE : "
Private Const FILE_SHAPE_SET_LINEWIDTH = vbTab & "LINEWIDTH : "
Private Const FILE_SHAPE_SET_RAPPMODE = vbTab & "RAPPRESENTATIONMODE : "
Private Const FILE_SHAPE_SET_SELECTED = vbTab & "SELECTED : "
Private Const FILE_SHAPE_SET_VISIBLE = vbTab & "VISIBLE : "
Private Const FILE_SHAPE_SET_N_INTERP_PTS = vbTab & "NUMBERINTERPOLATEDPOINTS : "
Private Const FILE_SHAPE_SET_CLOSED = vbTab & "CLOSED : "
Private Const FILE_SHAPE_SET_ID = vbTab & "IDENTIFICATION : "

'Point Setting Constants
Private Const FILE_POINT_SET_MARKERCOLOUR = vbTab & vbTab & "MARKERCOLOUR : "
Private Const FILE_POINT_SET_MARKERSIZE = vbTab & vbTab & "MARKERSIZE : "
Private Const FILE_POINT_SET_MARKERSTYLE = vbTab & vbTab & "MARKERSTYLE : "
Private Const FILE_POINT_SET_X = vbTab & vbTab & "X : "
Private Const FILE_POINT_SET_Y = vbTab & vbTab & "Y : "
Private Const FILE_POINT_SET_Z = vbTab & vbTab & "Z : "
Private Const FILE_POINT_SET_ENABLED = vbTab & vbTab & "ENABLED : "
Private Const FILE_POINT_SET_VISIBLE = vbTab & vbTab & "VISIBLE : "
Private Const FILE_POINT_SET_SELECTED = vbTab & vbTab & "SELECTED : "
Private Const FILE_POINT_SET_ID = vbTab & vbTab & "IDENTIFICATION : "
Private Const FILE_POINT_SET_MOVEABLE = vbTab & vbTab & "MOVEABLE : "
Private Const FILE_POINT_SET_INTERPOLANT = vbTab & vbTab & "INTERPOLANT : "
Private Const FILE_POINT_SET_OPENDELAY = vbTab & vbTab & "OPENDELAY : "
Private Const FILE_POINT_SET_CLOSEDELAY = vbTab & vbTab & "CLOSEDELAY : "
Private Const FILE_POINT_SET_BASE_X = vbTab & vbTab & "BASE X : "
Private Const FILE_POINT_SET_BASE_Y = vbTab & vbTab & "BASE Y : "
Private Const FILE_POINT_SET_BASE_Z = vbTab & vbTab & "BASE Z : "
Private Const FILE_POINT_SET_OFFSET_X = vbTab & vbTab & "OFFSET X: "
Private Const FILE_POINT_SET_OFFSET_Y = vbTab & vbTab & "OFFSET Y: "
Private Const FILE_POINT_SET_OFFSET_Z = vbTab & vbTab & "OFFSET Z: "
Private Const FILE_POINT_SET_PROCEDURE = vbTab & vbTab & "PROCEDURE : "
Private Const FILE_POINT_SET_TOOL_DISTANCE = vbTab & vbTab & "TOOLDISTANCE : "
Private Const FILE_POINT_SET_TOOL_NUMBER = vbTab & vbTab & "TOOLNUMBER : "
Private Const FILE_POINT_SET_ORIENTATION_O = vbTab & vbTab & "O : "
Private Const FILE_POINT_SET_ORIENTATION_A = vbTab & vbTab & "A : "
Private Const FILE_POINT_SET_ORIENTATION_T = vbTab & vbTab & "T : "
Private Const FILE_POINT_SET_OFFSET_ORIENTATION_X = vbTab & vbTab & "RX : "
Private Const FILE_POINT_SET_OFFSET_ORIENTATION_Y = vbTab & vbTab & "RY : "
Private Const FILE_POINT_SET_OFFSET_ORIENTATION_Z = vbTab & vbTab & "RZ : "
Private Const FILE_POINT_SET_ACCURACY = vbTab & vbTab & "ACCURACY : "
Private Const FILE_POINT_SET_STOP_PROC_TIME = vbTab & vbTab & "STOPPROCEDURETIME : "


Public Function Read_File(Filename As String, Find_Error As Boolean) As InBlu_Solid()
'Function that read a file and put its content
'in the collection
'INPUT PARAMETER:
'               FileName:Path of file where read
'OUTPUT PARAMETER:
'               ReadFile:Solids returned

    'Declarations
    Dim TmpStr As String
    Dim Str As String
    Dim Comment As String
    Dim SolidNumber As Long, ShapeNumber As Long, PointNumber As Long
    Dim I As Long, K As Long, M As Long
    Dim Find_File As Boolean
    
    'Temporary objects
    'Dim tmpCollection As Collection
    Dim tmpSolid() As InBlu_Solid
    Dim tmpShape As InBlu_Shape_3D
    Dim tmpPoint As InBlu_Point_3D
    
    'File Managers
    Dim Fso, FileManager
    Dim Orientation As Inblu_Angles
    Dim OffsetOrientation As Inblu_Angles
    Dim IPos As Long
    Dim FPos As Long
    Dim TmpPar As String
    Dim FirstPos As String
    Dim Speed As Long
    Dim ProcNum As Long
    Dim Accu As Long
    Dim ProcOn As Long
    Dim LastTool As Long
        
    'Error Handler
    On Error GoTo ErrorHandler
    
    'Load file manager
    Set Fso = CreateObject("Scripting.FileSystemObject")
    Find_File = Fso.FileExists(Filename)
    If Find_File = False Then
    
        Err.Raise 513
    
    End If
    
    Set FileManager = Fso.OpenTextFile(Filename)
    
    'Return file extension
    TmpStr = Fso.GetExtensionName(Filename)

    Select Case LCase(TmpStr)
            
        'Extension for GSS program
        Case "emo", "ori", "pat"
            
            'Eventually comment
            Comment = ReadComment(FileManager)
            
'            If Comment <> "" Then
'
'                frmComment.txtComment.Text = Comment
'                frmComment.txtComment.Enabled = False
'                frmComment.Caption = Filename
'
'                'Show comment
'                frmComment.Show 1
'
'                Unload frmComment
'
'                Set frmComment = Nothing
'
'            End If
            
            'Number of solids in the file
            SolidNumber = ReadSolidNumber(FileManager)
            
            ReDim tmpSolid(SolidNumber - 1)
            'Create solids for temporary collections
            For I = LBound(tmpSolid()) To UBound(tmpSolid())
            
                'Create a temporary solid
                Set tmpSolid(I) = New InBlu_Solid
                
                'Add temporary solid in the collection
                'tmpCollection.Add tmpSolid
            
                'Number of shapes in the solid
                ShapeNumber = ReadShapeNumber(FileManager, I + 1)
                
                For K = 1 To ShapeNumber
                
                    'Create a temporary shape
                    Set tmpShape = New InBlu_Shape_3D
                    
                    'Read shape setting
                    Set tmpShape = ReadShapeSetting(FileManager, K)
                    
                    'Add temporary shape to the solid
                    tmpSolid(I).AddShape tmpShape
                    
                    'Number of point in the shape
                    PointNumber = ReadPointNumber(FileManager, K)
                    
                    For M = 1 To PointNumber
                        
                        'Create a temporary point
                        Set tmpPoint = New InBlu_Point_3D
                        
                        'Read point setting
                        Set tmpPoint = ReadPointSetting(FileManager, M)
                        
                        'Add temporary point to the shape
                        tmpSolid(I).Shape(K).AddPoint tmpPoint
                        
                        'Delete temporary point
                        Set tmpPoint = Nothing
                    
                    Next M
                    
                    'Delete temporary shape
                    Set tmpShape = Nothing
                    
                Next K
            
                'Delete temporary solid
                'Set tmpSolid = Nothing
                
            Next I
            
        'Extension for Sil6 program
        Case "pa1", "pa2"
            'Number of solids in the file
            SolidNumber = ReadSolidNumber(FileManager)
            ReDim tmpSolid(SolidNumber - 1)
            'Create solids for temporary collections
            For I = LBound(tmpSolid()) To UBound(tmpSolid())
                'Create a temporary solid
                Set tmpSolid(I) = New InBlu_Solid
                'Add temporary solid in the collection
                'tmpCollection.Add tmpSolid
                'Number of shapes in the solid
                ShapeNumber = ReadShapeNumber(FileManager, I + 1)
                For K = 1 To ShapeNumber
                    'Create a temporary shape
                    Set tmpShape = New InBlu_Shape_3D
                    'Read shape setting
                    Set tmpShape = ReadShapeSetting(FileManager, K)
                    'Add temporary shape to the solid
                    tmpSolid(I).AddShape tmpShape
                    'Number of point in the shape
                    PointNumber = ReadPointNumber(FileManager, K)
                    For M = 1 To PointNumber
                        'Create a temporary point
                        Set tmpPoint = New InBlu_Point_3D
                        'Read point setting
                        Set tmpPoint = ReadPaintPointSetting(FileManager, M)
                        'Add temporary point to the shape
                        tmpSolid(I).Shape(K).AddPoint tmpPoint
                        'Delete temporary point
                        Set tmpPoint = Nothing
                    Next M
                    'Delete temporary shape
                    Set tmpShape = Nothing
                Next K
                'Delete temporary solid
                'Set tmpSolid = Nothing
            Next I
        'Extension for Robot program
        Case "txt"
        
        Case "lav"
            ReDim tmpSolid(0)
            Set tmpSolid(0) = New InBlu_Solid
            Set tmpShape = New InBlu_Shape_3D
            tmpShape.MarkerColour = 0
            tmpShape.Identification = Sprayer
            tmpShape.RappresentationMode = SplineAndMarker
            tmpSolid(0).AddShape tmpShape
            LastTool = 2
            Do While Mid(TmpStr, 1, 1) <> "0" Or Mid(TmpStr, 1, 1) <> ""
                Set tmpPoint = New InBlu_Point_3D
                Set Orientation = New Inblu_Angles
                Set OffsetOrientation = New Inblu_Angles
               'Point number
                TmpStr = FileManager.ReadLine
                If Mid(TmpStr, 1, 1) = "0" Or Mid(TmpStr, 1, 1) = "" Then
                    Exit Do
                End If
                FirstPos = InStr(1, TmpStr, ",")
                TmpPar = Mid(TmpStr, 1, FirstPos - 1)
                If Mid(TmpStr, 1, 1) = "0" Then Exit Do
                'XValue
                IPos = InStr(FirstPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.BaseX = Val(TmpPar)
                'YValue
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.BaseY = Val(TmpPar)
                'ZValue
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.BaseZ = Val(TmpPar)
                tmpPoint.Orientation.AngleType = "ZYZ"
                'OValue
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.Orientation.First = Val(TmpPar)
                'AValue
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.Orientation.Second = Val(TmpPar)
                'TValue
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.Orientation.Third = Val(TmpPar)
                'XOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetX = Val(TmpPar)
                'YOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetY = Val(TmpPar)
                'ZOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetZ = Val(TmpPar)
                tmpPoint.OffsetOrientation.AngleType = "ZYX"
                'RXOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetOrientation.First = Val(TmpPar)
                'RYOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetOrientation.Second = Val(TmpPar)
                'RZOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetOrientation.Third = Val(TmpPar)
                'Nothing
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                'Nothing
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                'Speed & Proc
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                Speed = Int(Val(TmpPar) / 32)
                'Differente type of file can be created by SIL6,in this case
                'translator program terminate to read the file.
                If Speed = 0 Then Exit Do
                
                tmpPoint.MarkerColour = Write_Speed_Associations(Speed)
                ProcNum = Val(TmpPar) - Speed * 32
                If ProcNum = 1 Then
                    tmpPoint.ToolNumber = 2
                    LastTool = 2
                ElseIf ProcNum = 5 Then
                    tmpPoint.ToolNumber = 1
                    LastTool = 1
                Else
                    tmpPoint.ToolNumber = LastTool
                End If
                'Accu & proc state
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                Accu = Int(Val(TmpPar) / 256)
                ProcOn = TmpPar - Accu * 256
                If ProcOn = 1 And ProcNum <> 0 Then
                    tmpPoint.Procedure = 1
                ElseIf ProcOn = 0 And ProcNum <> 0 Then
                    tmpPoint.Procedure = 2
                Else
                    tmpPoint.Procedure = 0
                End If
                tmpPoint.Accuracy = 1000
                tmpPoint.StopProcedureTime = 0
                tmpPoint.CloseDelay = 0
                tmpSolid(0).Shape(1).AddPoint tmpPoint
                Set tmpPoint = Nothing
                Set Orientation = Nothing
                Set OffsetOrientation = Nothing
            Loop
            Set tmpPoint = Nothing
            Set Orientation = Nothing
            Set OffsetOrientation = Nothing
        Case "au1"
            ReDim tmpSolid(0)
            Set tmpSolid(0) = New InBlu_Solid
            Set tmpShape = New InBlu_Shape_3D
            tmpShape.MarkerColour = 0
            tmpShape.Identification = Sprayer
            tmpShape.RappresentationMode = SplineAndMarker
            tmpSolid(0).AddShape tmpShape
            LastTool = 1
            Do While Mid(TmpStr, 1, 1) <> "0" Or Mid(TmpStr, 1, 1) <> ""
                Set tmpPoint = New InBlu_Point_3D
                Set Orientation = New Inblu_Angles
                Set OffsetOrientation = New Inblu_Angles
               'Point number
                TmpStr = FileManager.ReadLine
                If Mid(TmpStr, 1, 1) = "0" Or Mid(TmpStr, 1, 1) = "" Then
                    Exit Do
                End If
                FirstPos = InStr(1, TmpStr, ",")
                TmpPar = Mid(TmpStr, 1, FirstPos - 1)
                If Mid(TmpStr, 1, 1) = "0" Then Exit Do
                'XValue
                IPos = InStr(FirstPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.BaseX = Val(TmpPar)
                'YValue
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.BaseY = Val(TmpPar)
                'ZValue
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.BaseZ = Val(TmpPar)
                tmpPoint.Orientation.AngleType = "ZYZ"
                'OValue
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.Orientation.First = Val(TmpPar)
                'AValue
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.Orientation.Second = Val(TmpPar)
                'TValue
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.Orientation.Third = Val(TmpPar)
                'XOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetX = Val(TmpPar)
                'YOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetY = Val(TmpPar)
                'ZOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetZ = Val(TmpPar)
                tmpPoint.OffsetOrientation.AngleType = "ZYX"
                'RXOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetOrientation.First = Val(TmpPar)
                'RYOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetOrientation.Second = Val(TmpPar)
                'RZOff
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                tmpPoint.OffsetOrientation.Third = Val(TmpPar)
                'Nothing
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                'Nothing
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                'Speed & Proc
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                Speed = Int(Val(TmpPar) / 32)
                'Differente type of file can be created by SIL6,in this case
                'translator program terminate to read the file.
                If Speed = 0 Then Exit Do
                
                tmpPoint.MarkerColour = Write_Speed_Associations(Speed)
                ProcNum = Val(TmpPar) - Speed * 32
                If ProcNum = 1 Then
                    tmpPoint.ToolNumber = 2
                    LastTool = 2
                ElseIf ProcNum = 5 Then
                    tmpPoint.ToolNumber = 1
                    LastTool = 1
                Else
                    tmpPoint.ToolNumber = LastTool
                End If
                'Accu & proc state
                IPos = InStr(FPos, TmpStr, ",")
                FPos = InStr(IPos + 1, TmpStr, ",")
                TmpPar = Mid(TmpStr, IPos + 1, FPos - IPos - 1)
                Accu = Int(Val(TmpPar) / 256)
                ProcOn = Val(TmpPar) - Accu * 256
                If ProcOn = 1 And ProcNum <> 0 Then
                    tmpPoint.Procedure = 1
                ElseIf ProcOn = 0 And ProcNum <> 0 Then
                    tmpPoint.Procedure = 2
                Else
                    tmpPoint.Procedure = 0
                End If
                tmpPoint.Accuracy = 1000
                tmpPoint.StopProcedureTime = 0
                tmpPoint.CloseDelay = 0
                tmpSolid(0).Shape(1).AddPoint tmpPoint
                Set tmpPoint = Nothing
                Set Orientation = Nothing
                Set OffsetOrientation = Nothing
            Loop
            Set tmpPoint = Nothing
            Set Orientation = Nothing
            Set OffsetOrientation = Nothing
    End Select
    'Return obtained collection
    Read_File = tmpSolid()
    'Set tmpShape = Nothing
    'Set tmpSolid(1) = Nothing
    'Set tmpPoint = Nothing
ErrorHandler:      Select Case Err.Number
                        Case 13:
                            MsgBox "error" 'LoadResString(402), vbInformation, LoadResString(368)
'                           MsgBox "Il file che si vuole aprire contiene degli errori ", vbInformation, "Comunicazione di Sistema"
                            Find_Error = True
                        Case 62:
                            MsgBox "error" ' LoadResString(402), vbInformation, LoadResString(368)
'                           MsgBox "Il file che si vuole aprire contiene degli errori ", vbInformation, "Comunicazione di Sistema"
                            Find_Error = True
                        Case 513:
                            Find_Error = True
                   End Select
'    Set tmpSolid() = Nothing
End Function


Public Sub Write_File(Filename As String, tmpCollection As Collection)
'Function that write in the destination folder a file that will contain
'the points inside the collection in the format based on the extension
'of FileName
'INPUT PARAMETER:
'               FileName:File where save the points
'               tmpCollection:Collection of points

    'Declarations
    Dim TmpStr As String
'    Dim Str As String
    Dim Comment As String
    Dim I As Long, K As Long, M As Long
    Dim SolidsSaveable As Long
    Dim Fso, FileManager
    
    'Load file manager
    Set Fso = CreateObject("Scripting.FileSystemObject")
    Set FileManager = Fso.CreateTextFile(UCase(Filename), True)

    'Return file extension
    TmpStr = Fso.GetExtensionName(Filename)

    Select Case LCase(TmpStr)
        'Extension for GSS program
        Case "emo", "ori", "pat"
            '*******************************************
            'ATTENZIONE:
            'Successivamente si inserir il controllo
            'su una chiave di registro per poter inibire
            'la funzione di commento
            '*******************************************
'            frmComment.Caption = Filename
'            'Form for comment insertion
'            frmComment.Show 1
'            'User can insert a comment to him file
'            Comment = frmComment.txtComment.Text
'            Unload frmComment
'            Set frmComment = Nothing
            'No comment
            If Comment = "" Then
                Comment = " "
            End If
            'Write comment in the file
            WriteComment FileManager, Comment
            WriteSolidInfo FileManager, Trim(Str(tmpCollection.Count))
            
            For I = 1 To tmpCollection.Count
                'Write solid number
                WriteSolidNum FileManager, Trim(Str(I))
                WriteShapeInfo FileManager, Trim(Str(tmpCollection.Item(I).ShapesNumber))
                For K = 1 To tmpCollection.Item(I).ShapesNumber
                    'Write shape number
                    WriteShapeNum FileManager, Trim(Str(K))
                    If LCase(TmpStr) = "ori" Then tmpCollection.Item(I).Shape(K).LineStyle = 1
                    If LCase(TmpStr) = "pat" Then tmpCollection.Item(I).Shape(K).LineStyle = 2
                    WriteShapeSettings FileManager, tmpCollection.Item(I).Shape(K)
                    WritePointInfo FileManager, Trim(Str(tmpCollection.Item(I).Shape(K).PointsNumber))
                    For M = 1 To tmpCollection.Item(I).Shape(K).PointsNumber
                        WritePointNum FileManager, Trim(Str(M))
                        WritePointSettings FileManager, tmpCollection.Item(I).Shape(K).Point(M)
                    Next M
                Next K
            Next I
        'Extension for Sil6 program
        Case "pa1", "pa2"
        
            '*******************************************
            'ATTENZIONE:
            'Successivamente si inserir il controllo
            'su una chiave di registro per poter inibire
            'la funzione di commento
            '*******************************************
            
            
'            frmComment.Caption = Filename
'            'Form for comment insertion
'            frmComment.Show 1
'
'            'User can insert a comment to him file
'            Comment = frmComment.txtComment.Text
'
'            Unload frmComment
'
'            Set frmComment = Nothing
'
'            'No comment
'            If Comment = "" Then
            Comment = " "
'            End If
            'Write comment in the file
            WriteComment FileManager, Comment
            SolidsSaveable = 0
            
            For I = 1 To tmpCollection.Count
                If tmpCollection.Item(I).Saveable Then
                    SolidsSaveable = SolidsSaveable + 1
                End If
            Next I
            WriteSolidInfo FileManager, Trim(Str(SolidsSaveable))
            SolidsSaveable = 1
            For I = 1 To tmpCollection.Count
                If tmpCollection.Item(I).Saveable Then
                    'Write solid number
                    WriteSolidNum FileManager, Trim(Str(SolidsSaveable))
                    WriteShapeInfo FileManager, Trim(Str(tmpCollection.Item(I).ShapesNumber))
                    For K = 1 To tmpCollection.Item(I).ShapesNumber
                        'Write shape number
                        WriteShapeNum FileManager, Trim(Str(K))
                        WriteShapeSettings FileManager, tmpCollection.Item(I).Shape(K)
                        WritePointInfo FileManager, Trim(Str(tmpCollection.Item(I).Shape(K).PointsNumber))

                        For M = 1 To tmpCollection.Item(I).Shape(K).PointsNumber
                            WritePointNum FileManager, Trim(Str(M))
                            WritePaintPointSettings FileManager, tmpCollection.Item(I).Shape(K).Point(M)
                        Next M
                    Next K
                    SolidsSaveable = SolidsSaveable + 1
                End If
            Next I
        'Extension for Robot program
        Case "txt"
    End Select
    FileManager.Close
End Sub

Private Function ReadSolidNumber(ByVal FileManager) As Long
'Function that determine how many solids are saved in the file
'INPUT PARAMETER:
'               FileManager:Object that manage file functions
'OUTPUT PARAMETER:
'               ReadSolidNumber:Return number of solids in the file

    'Declarations
    Dim tmpSolidNumber As Long
    Dim TmpStr As String
    Dim PosStringSeparator As Long
    
    Do
        TmpStr = FileManager.ReadLine
    Loop Until UCase(TmpStr) = FILE_SOLIDINFO
    'Extract number of solid
    TmpStr = FileManager.ReadLine
    PosStringSeparator = InStr(1, TmpStr, ":")
    tmpSolidNumber = Mid$(TmpStr, PosStringSeparator + 1)
    'Return number of solids
    ReadSolidNumber = tmpSolidNumber
End Function

Private Function ReadComment(ByVal FileManager) As String
'Function that read an evetually comment of file
'INPUT PARAMETER:
'               FileManager:Object that manage file functions
'OUTPUT PARAMETER:
'               ReadComment:Return comment string

    'Declarations
    Dim EscChr As String
    Dim Comment As String
    Dim TmpStr As String

    Comment = ""
    
    'Cycle that read an eventually comment in the file
    Do
    
        Comment = Comment & " " & TmpStr
        TmpStr = FileManager.ReadLine
        
'        Debug.Assert False
        
    Loop Until TmpStr = FILE_SEPARATOR

    'Return comment string
    ReadComment = Comment
    
End Function

Private Function ReadShapeNumber(ByVal FileManager, ByVal IDSolid As Long) As Long
'Function that determine how many shapes are saved in a solid
'INPUT PARAMETER:
'               FileManager:Object that manage file functions
'               IDSolid:Index of solid
'OUTPUT PARAMETER:
'               ReadShapeNumber:Return number of shapes in the file

    'Declarations
    Dim Escstr As String
    Dim tmpShapeNumber As Long
    Dim TmpStr As String
    Dim PosSeparator As Long
    
    'Escape string
    Escstr = FILE_SOLIDLABEL & Trim(Str(IDSolid)) & " : "
        
    Do
    
        TmpStr = FileManager.ReadLine
        
    Loop Until TmpStr = Escstr
    
    'Escape string
    Escstr = FILE_SHAPEINFO
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until TmpStr = Escstr

    'Extract number of shapes
    TmpStr = FileManager.ReadLine
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShapeNumber = Mid$(TmpStr, PosSeparator + 1)
        
    'Return number of shapes
    ReadShapeNumber = tmpShapeNumber
    
End Function

Private Function ReadShapeSetting(ByVal FileManager, ByVal IDShape As Long) As InBlu_Shape_3D
'Function that extract the values of shape properties
'INPUT PARAMETER:
'               FileManager:Object that manage file functions
'               IDShape:Index of shape
'OUTPUT PARAMETER:
'               ReadShapeSettings:Return setting of shape

    'Declarations
    Dim Escstr As String
    Dim tmpShape As InBlu_Shape_3D
    Dim TmpStr As String
    Dim PosSeparator As Long
    
    'Escape string
    Escstr = FILE_SHAPELABEL & Trim(Str(IDShape)) & " : "
        
    Do
    
        TmpStr = FileManager.ReadLine
        
    Loop Until TmpStr = Escstr
    
    'Escape string
    Escstr = FILE_SHAPE_SET_MARKERCOLOUR
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0

    'Create temporary shape
    Set tmpShape = New InBlu_Shape_3D
    
    'Extract linecolour property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.MarkerColour = CLng(Mid$(TmpStr, PosSeparator + 1))
    
    'Escape string
    Escstr = FILE_SHAPE_SET_MARKERSIZE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0

    'Extract linecolour property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.MarkerSize = CLng(Mid$(TmpStr, PosSeparator + 1))
    
    'Escape string
    Escstr = FILE_SHAPE_SET_MARKERSTYLE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0

    'Extract linecolour property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.MarkerStyle = Mid$(TmpStr, PosSeparator + 1)
    
    'Escape string
    Escstr = FILE_SHAPE_SET_LINECOLOUR
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract linecolour property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.LineColour = Mid$(TmpStr, PosSeparator + 1)
    
    'Escape string
    Escstr = FILE_SHAPE_SET_LINESTYLE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract linestyle property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.LineStyle = Mid$(TmpStr, PosSeparator + 1)
    
    'Escape string
    Escstr = FILE_SHAPE_SET_LINEWIDTH
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0

    
    'Extract linewidth property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.LineWidth = Mid$(TmpStr, PosSeparator + 1)
    
    'Escape string
    Escstr = FILE_SHAPE_SET_RAPPMODE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract rappresentationmode property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.RappresentationMode = CLng(Mid$(TmpStr, PosSeparator + 1))
    
    'Escape string
    Escstr = FILE_SHAPE_SET_VISIBLE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract visible property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.Visible = CBool(Mid$(TmpStr, PosSeparator + 1))
    
    'Escape string
    Escstr = FILE_SHAPE_SET_N_INTERP_PTS
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract visible property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.NumberInterpolatedPoints = Val(Mid$(TmpStr, PosSeparator + 1))
    
    'Escape string
    Escstr = FILE_SHAPE_SET_CLOSED

    Do

        TmpStr = FileManager.ReadLine

    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract selected property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.Closed = CBool(Mid(TmpStr, PosSeparator + 1))
    
    'Escape string
    Escstr = FILE_SHAPE_SET_ID

    Do

        TmpStr = FileManager.ReadLine

    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract selected property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpShape.Identification = Mid(TmpStr, PosSeparator + 1)

    Set ReadShapeSetting = tmpShape
               
End Function

Private Function ReadPointNumber(ByVal FileManager, ByVal IDShape As Long) As Long
'Function that determine how many points are in the shape
'INPUT PARAMETER:
'               FileManager:Object that manage file functions
'               IDShape:Index of shape
'OUTPUT PARAMETER:
'               ReadPointNumber:Return number of points in the file

    'Declarations
    Dim Escstr As String
    Dim tmpPointNumber As Long
    Dim TmpStr As String
    Dim PosSeparator As Long
    
    'Escape string
    Escstr = FILE_POINTINFO
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until TmpStr = Escstr

    'Extract number of points
    TmpStr = FileManager.ReadLine
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPointNumber = Mid$(TmpStr, PosSeparator + 1)
        
    'Return number of points
    ReadPointNumber = tmpPointNumber
    
End Function

Private Function ReadPointSetting(ByVal FileManager, ByVal IDPoint As Long) As InBlu_Point_3D
'Function that read the properties of point in the file
'INPUT PARAMETER:
'               FileManager:Object that manage file functions
'               IDPoint:Index of point
'OUTPUT PARAMETER:
'               ReadPointSetting:Return setting of point properties

    'Declarations
    Dim Escstr As String
    Dim tmpPoint As InBlu_Point_3D
    Dim TmpStr As String
    Dim PosSeparator As Long
    
    'Create temporary point
    Set tmpPoint = New InBlu_Point_3D
   
    'Escape string
    Escstr = FILE_POINTLABEL & Trim(Str(IDPoint)) & " : "
        
    Do
    
        TmpStr = FileManager.ReadLine
        
    Loop Until TmpStr = Escstr
    
    'Escape string
    Escstr = FILE_POINT_SET_MARKERCOLOUR
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0

     
    'Extract markercolour property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.MarkerColour = Mid$(TmpStr, PosSeparator + 1)
    
    'Escape string
    Escstr = FILE_POINT_SET_MARKERSIZE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0

    'Extract markersize property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.MarkerSize = Mid$(TmpStr, PosSeparator + 1)
    
    'Escape string
    Escstr = FILE_POINT_SET_MARKERSTYLE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract markerstyle property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.MarkerStyle = Mid$(TmpStr, PosSeparator + 1)
    
'    'Escape string
'    Escstr = FILE_POINT_SET_X
'
'    Do
'
'        TmpStr = FileManager.Readline
'
'    Loop Until InStr(1, TmpStr, Escstr) <> 0
'
'
'    'Extract x property from file
'    PosSeparator = InStr(1, TmpStr, ":")
'    tmpPoint.X = Mid$(TmpStr, PosSeparator + 1)
'
'    'Escape string
'    Escstr = FILE_POINT_SET_Y
'
'    Do
'
'        TmpStr = FileManager.Readline
'
'    Loop Until InStr(1, TmpStr, Escstr) <> 0
'
'
'    'Extract y property from file
'    PosSeparator = InStr(1, TmpStr, ":")
'    tmpPoint.Y = Mid$(TmpStr, PosSeparator + 1)
'
'    'Escape string
'    Escstr = FILE_POINT_SET_Z
'
'    Do
'
'        TmpStr = FileManager.Readline
'
'    Loop Until InStr(1, TmpStr, Escstr) <> 0
'
'
'    'Extract z property from file
'    PosSeparator = InStr(1, TmpStr, ":")
'    tmpPoint.Z = Mid$(TmpStr, PosSeparator + 1)
    
    'Escape string
    Escstr = FILE_POINT_SET_ENABLED
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract enabled property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Enabled = CBool(Mid$(TmpStr, PosSeparator + 1))
    
    
    'Escape string
    Escstr = FILE_POINT_SET_VISIBLE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract visible property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Visible = CBool(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_ID
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Identification = Mid$(TmpStr, PosSeparator + 1)

    'Escape string
    Escstr = FILE_POINT_SET_MOVEABLE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0

    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Moveable = CBool(Mid$(TmpStr, PosSeparator + 1))

    
    'Escape string
    Escstr = FILE_POINT_SET_INTERPOLANT
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract interpolant property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Interpolant = CBool(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_X
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetX = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_Y
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetY = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_Z
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetZ = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_BASE_X
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.BaseX = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_BASE_Y
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.BaseY = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_BASE_Z
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.BaseZ = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_ORIENTATION_O
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Orientation.First = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_ORIENTATION_A
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Orientation.Second = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_ORIENTATION_T
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Orientation.Third = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_ORIENTATION_X
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetOrientation.First = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_ORIENTATION_Y
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetOrientation.Second = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_ORIENTATION_Z
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetOrientation.Third = Val(Mid$(TmpStr, PosSeparator + 1))

    Set ReadPointSetting = tmpPoint
    
    Set tmpPoint = Nothing
               
End Function

Private Function ReadPaintPointSetting(ByVal FileManager, ByVal IDPoint As Long) As InBlu_Point_3D
'Function that read the properties of point in the file
'INPUT PARAMETER:
'               FileManager:Object that manage file functions
'               IDPoint:Index of point
'OUTPUT PARAMETER:
'               ReadPointSetting:Return setting of point properties

    'Declarations
    Dim Escstr As String
    Dim tmpPoint As InBlu_Point_3D
    Dim TmpStr As String
    Dim PosSeparator As Long
    
    'Create temporary point
    Set tmpPoint = New InBlu_Point_3D
   
    'Escape string
    Escstr = FILE_POINTLABEL & Trim(Str(IDPoint)) & " : "
        
    Do
    
        TmpStr = FileManager.ReadLine
        
    Loop Until TmpStr = Escstr
    
    'Escape string
    Escstr = FILE_POINT_SET_MARKERCOLOUR
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0

     
    'Extract markercolour property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.MarkerColour = Mid$(TmpStr, PosSeparator + 1)
    
    'Escape string
    Escstr = FILE_POINT_SET_MARKERSIZE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0

    'Extract markersize property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.MarkerSize = Mid$(TmpStr, PosSeparator + 1)
    
    'Escape string
    Escstr = FILE_POINT_SET_MARKERSTYLE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract markerstyle property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.MarkerStyle = Mid$(TmpStr, PosSeparator + 1)
    
'    'Escape string
'    Escstr = FILE_POINT_SET_X
'
'    Do
'
'        TmpStr = FileManager.Readline
'
'    Loop Until InStr(1, TmpStr, Escstr) <> 0
'
'
'    'Extract x property from file
'    PosSeparator = InStr(1, TmpStr, ":")
'    tmpPoint.X = Mid$(TmpStr, PosSeparator + 1)
'
'    'Escape string
'    Escstr = FILE_POINT_SET_Y
'
'    Do
'
'        TmpStr = FileManager.Readline
'
'    Loop Until InStr(1, TmpStr, Escstr) <> 0
'
'
'    'Extract y property from file
'    PosSeparator = InStr(1, TmpStr, ":")
'    tmpPoint.Y = Mid$(TmpStr, PosSeparator + 1)
'
'    'Escape string
'    Escstr = FILE_POINT_SET_Z
'
'    Do
'
'        TmpStr = FileManager.Readline
'
'    Loop Until InStr(1, TmpStr, Escstr) <> 0
'
'
'    'Extract z property from file
'    PosSeparator = InStr(1, TmpStr, ":")
'    tmpPoint.Z = Mid$(TmpStr, PosSeparator + 1)
    
    'Escape string
    Escstr = FILE_POINT_SET_ENABLED
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract enabled property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Enabled = CBool(Mid$(TmpStr, PosSeparator + 1))
    
    
    'Escape string
    Escstr = FILE_POINT_SET_VISIBLE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract visible property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Visible = CBool(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_ID
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Identification = Mid$(TmpStr, PosSeparator + 1)

    'Escape string
    Escstr = FILE_POINT_SET_MOVEABLE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0

    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Moveable = CBool(Mid$(TmpStr, PosSeparator + 1))

    
    'Escape string
    Escstr = FILE_POINT_SET_INTERPOLANT
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract interpolant property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Interpolant = CBool(Mid$(TmpStr, PosSeparator + 1))

    
    'Escape string
    Escstr = FILE_POINT_SET_OPENDELAY
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OpenDelay = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_CLOSEDELAY
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.CloseDelay = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_X
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetX = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_Y
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetY = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_Z
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetZ = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_BASE_X
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.BaseX = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_BASE_Y
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.BaseY = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_BASE_Z
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.BaseZ = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_PROCEDURE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Procedure = CLng(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_TOOL_DISTANCE
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.ToolDistance = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_TOOL_NUMBER
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.ToolNumber = CLng(Mid$(TmpStr, PosSeparator + 1))


    'Escape string
    Escstr = FILE_POINT_SET_ORIENTATION_O
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Orientation.First = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_ORIENTATION_A
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Orientation.Second = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_ORIENTATION_T
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Orientation.Third = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_ORIENTATION_X
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetOrientation.First = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_ORIENTATION_Y
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetOrientation.Second = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_OFFSET_ORIENTATION_Z
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.OffsetOrientation.Third = Val(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_ACCURACY
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.Accuracy = CLng(Mid$(TmpStr, PosSeparator + 1))

    'Escape string
    Escstr = FILE_POINT_SET_STOP_PROC_TIME
    
    Do
    
        TmpStr = FileManager.ReadLine
    
    Loop Until InStr(1, TmpStr, Escstr) <> 0


    'Extract identification property from file
    PosSeparator = InStr(1, TmpStr, ":")
    tmpPoint.StopProcedureTime = Val(Mid$(TmpStr, PosSeparator + 1))

    Set ReadPaintPointSetting = tmpPoint
    
    Set tmpPoint = Nothing
               
End Function

Private Function WriteComment(ByVal FileManager, ByVal Header As String)

    'Write a comment in the top of the file
    FileManager.WriteLine Header
    

End Function

Private Function WriteSolidInfo(ByVal FileManager, ByVal NumberOfSolid As String)
'************************************************
'Fare i commenti
'************************************************
    FileManager.WriteLine FILE_SEPARATOR
    FileManager.WriteLine FILE_SOLIDINFO
    FileManager.WriteLine FILE_N_SOLID & NumberOfSolid

End Function

Private Function WriteSolidNum(ByVal FileManager, ByVal SolidNumber As String)
'************************************************
'Fare i commenti
'************************************************

    FileManager.WriteLine FILE_SEPARATOR
    FileManager.WriteLine FILE_SOLIDLABEL & SolidNumber & " : "
    
End Function

Private Function WriteShapeInfo(ByVal FileManager, ByVal NumberOfShapes As String)
'************************************************
'Fare i commenti
'************************************************

    FileManager.WriteLine FILE_SEPARATOR
    FileManager.WriteLine FILE_SHAPEINFO
    FileManager.WriteLine FILE_N_SHAPE & NumberOfShapes

End Function

Private Function WriteShapeNum(ByVal FileManager, ByVal ShapeNumber As String)
'************************************************
'Fare i commenti
'************************************************

    FileManager.WriteLine FILE_SEPARATOR
    FileManager.WriteLine FILE_SHAPELABEL & ShapeNumber & " : "
    
End Function

Private Function WriteShapeSettings(ByVal FileManager, ByVal tmpShape As InBlu_Shape_3D)
'************************************************
'Fare i commenti
'************************************************

    FileManager.WriteLine FILE_SEPARATOR
    FileManager.WriteLine FILE_SHAPE_SET_MARKERCOLOUR & Trim(Str(tmpShape.MarkerColour))
    FileManager.WriteLine FILE_SHAPE_SET_MARKERSIZE & Trim(Str(tmpShape.MarkerSize))
    FileManager.WriteLine FILE_SHAPE_SET_MARKERSTYLE & Trim(tmpShape.MarkerStyle)
    FileManager.WriteLine FILE_SHAPE_SET_LINECOLOUR & Trim(Str(tmpShape.LineColour))
    FileManager.WriteLine FILE_SHAPE_SET_LINESTYLE & Trim(Str(tmpShape.LineStyle))
    FileManager.WriteLine FILE_SHAPE_SET_LINEWIDTH & Trim(Str(tmpShape.LineWidth))
    FileManager.WriteLine FILE_SHAPE_SET_RAPPMODE & Trim(Str(tmpShape.RappresentationMode))
    FileManager.WriteLine FILE_SHAPE_SET_VISIBLE & CLng(tmpShape.Visible)
    FileManager.WriteLine FILE_SHAPE_SET_N_INTERP_PTS & Trim(Str(tmpShape.NumberInterpolatedPoints))
    FileManager.WriteLine FILE_SHAPE_SET_CLOSED & CLng(tmpShape.Closed)
    FileManager.WriteLine FILE_SHAPE_SET_ID & CLng(tmpShape.Identification)
    
End Function

Private Function WritePointInfo(ByVal FileManager, ByVal NumberOfPoints As String)
'************************************************
'Fare i commenti
'************************************************

    FileManager.WriteLine FILE_SEPARATOR
    FileManager.WriteLine FILE_POINTINFO
    FileManager.WriteLine FILE_N_POINT & NumberOfPoints

End Function

Private Function WritePointNum(ByVal FileManager, ByVal PointNumber As String)
'************************************************
'Fare i commenti
'************************************************

    FileManager.WriteLine FILE_SEPARATOR
    FileManager.WriteLine FILE_POINTLABEL & PointNumber & " : "
    
End Function

Private Function WritePointSettings(ByVal FileManager, ByVal tmpPoint As InBlu_Point_3D)
'************************************************
'Fare i commenti
'************************************************

    FileManager.WriteLine FILE_SEPARATOR
    FileManager.WriteLine FILE_POINT_SET_MARKERCOLOUR & Trim(Str(tmpPoint.MarkerColour))
    FileManager.WriteLine FILE_POINT_SET_MARKERSIZE & Trim(Str(tmpPoint.MarkerSize))
    FileManager.WriteLine FILE_POINT_SET_MARKERSTYLE & Trim(tmpPoint.MarkerStyle)
    FileManager.WriteLine FILE_POINT_SET_ENABLED & CLng(tmpPoint.Enabled)
    FileManager.WriteLine FILE_POINT_SET_VISIBLE & CLng(tmpPoint.Visible)
    FileManager.WriteLine FILE_POINT_SET_ID & tmpPoint.Identification
    FileManager.WriteLine FILE_POINT_SET_MOVEABLE & CLng(tmpPoint.Moveable)
    FileManager.WriteLine FILE_POINT_SET_INTERPOLANT & CLng(tmpPoint.Interpolant)
    FileManager.WriteLine FILE_POINT_SET_OPENDELAY & Trim(Str(tmpPoint.OpenDelay))
    FileManager.WriteLine FILE_POINT_SET_CLOSEDELAY & Trim(Str(tmpPoint.CloseDelay))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_X & Trim(Str(tmpPoint.OffsetX))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_Y & Trim(Str(tmpPoint.OffsetY))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_Z & Trim(Str(tmpPoint.OffsetZ))
    FileManager.WriteLine FILE_POINT_SET_BASE_X & Trim(Str(tmpPoint.BaseX))
    FileManager.WriteLine FILE_POINT_SET_BASE_Y & Trim(Str(tmpPoint.BaseY))
    FileManager.WriteLine FILE_POINT_SET_BASE_Z & Trim(Str(tmpPoint.BaseZ))
    FileManager.WriteLine FILE_POINT_SET_ORIENTATION_O & Trim(Str(tmpPoint.Orientation.First))
    FileManager.WriteLine FILE_POINT_SET_ORIENTATION_A & Trim(Str(tmpPoint.Orientation.Second))
    FileManager.WriteLine FILE_POINT_SET_ORIENTATION_T & Trim(Str(tmpPoint.Orientation.Third))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_ORIENTATION_X & Trim(Str(tmpPoint.OffsetOrientation.First))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_ORIENTATION_Y & Trim(Str(tmpPoint.OffsetOrientation.Second))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_ORIENTATION_Z & Trim(Str(tmpPoint.OffsetOrientation.Third))

End Function

Private Function WritePaintPointSettings(ByVal FileManager, ByVal tmpPoint As InBlu_Point_3D)
'************************************************
'Fare i commenti
'************************************************

    FileManager.WriteLine FILE_SEPARATOR
    FileManager.WriteLine FILE_POINT_SET_MARKERCOLOUR & Trim(Str(tmpPoint.MarkerColour))
    FileManager.WriteLine FILE_POINT_SET_MARKERSIZE & Trim(Str(tmpPoint.MarkerSize))
    FileManager.WriteLine FILE_POINT_SET_MARKERSTYLE & Trim(tmpPoint.MarkerStyle)
    FileManager.WriteLine FILE_POINT_SET_ENABLED & CLng(tmpPoint.Enabled)
    FileManager.WriteLine FILE_POINT_SET_VISIBLE & CLng(tmpPoint.Visible)
    FileManager.WriteLine FILE_POINT_SET_ID & tmpPoint.Identification
    FileManager.WriteLine FILE_POINT_SET_MOVEABLE & CLng(tmpPoint.Moveable)
    FileManager.WriteLine FILE_POINT_SET_INTERPOLANT & CLng(tmpPoint.Interpolant)
    FileManager.WriteLine FILE_POINT_SET_OPENDELAY & Trim(Str(tmpPoint.OpenDelay))
    FileManager.WriteLine FILE_POINT_SET_CLOSEDELAY & Trim(Str(tmpPoint.CloseDelay))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_X & Trim(Str(tmpPoint.OffsetX))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_Y & Trim(Str(tmpPoint.OffsetY))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_Z & Trim(Str(tmpPoint.OffsetZ))
    FileManager.WriteLine FILE_POINT_SET_BASE_X & Trim(Str(tmpPoint.BaseX))
    FileManager.WriteLine FILE_POINT_SET_BASE_Y & Trim(Str(tmpPoint.BaseY))
    FileManager.WriteLine FILE_POINT_SET_BASE_Z & Trim(Str(tmpPoint.BaseZ))
    FileManager.WriteLine FILE_POINT_SET_PROCEDURE & Trim(Str(tmpPoint.Procedure))
    FileManager.WriteLine FILE_POINT_SET_TOOL_DISTANCE & Trim(Str(tmpPoint.ToolDistance))
    FileManager.WriteLine FILE_POINT_SET_TOOL_NUMBER & Trim(Str(tmpPoint.ToolNumber))
    FileManager.WriteLine FILE_POINT_SET_ORIENTATION_O & Trim(Str(tmpPoint.Orientation.First))
    FileManager.WriteLine FILE_POINT_SET_ORIENTATION_A & Trim(Str(tmpPoint.Orientation.Second))
    FileManager.WriteLine FILE_POINT_SET_ORIENTATION_T & Trim(Str(tmpPoint.Orientation.Third))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_ORIENTATION_X & Trim(Str(tmpPoint.OffsetOrientation.First))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_ORIENTATION_Y & Trim(Str(tmpPoint.OffsetOrientation.Second))
    FileManager.WriteLine FILE_POINT_SET_OFFSET_ORIENTATION_Z & Trim(Str(tmpPoint.OffsetOrientation.Third))
    FileManager.WriteLine FILE_POINT_SET_ACCURACY & Trim(Str(tmpPoint.Accuracy))
    FileManager.WriteLine FILE_POINT_SET_STOP_PROC_TIME & Trim(Str(tmpPoint.StopProcedureTime))

End Function

