VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Inblu_Geom_Calculator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'GEOMETRY
'Public Function CalculateCosPlane(ByRef Point1 As InBlu_Point_3D, ByRef Point2 As InBlu_Point_3D, ByRef Point3 As InBlu_Point_3D) As Inblu_Cos_Axes
'Public Function CalculateDirectorCosines(ByRef Point_A As InBlu_Point_3D, ByRef Point_B As InBlu_Point_3D) As Inblu_Cos_Axes

'ROBOTICS
'Public Sub CompleteAxes(ByRef X_Axes_Cos As Inblu_Cos_Axes, ByRef Y_Axes_Cos As Inblu_Cos_Axes, ByRef Z_Axes_Cos As Inblu_Cos_Axes, ByRef Origin As InBlu_Point_3D, ByRef X_Direction As InBlu_Point_3D, ByRef Y_Direction As InBlu_Point_3D)
'Public Sub Trasl(X As Double, Y As Double, Z As Double, TraslMatrix() As Double)
'Public Sub RotY(Angle As Double, RotMatrix() As Double)
'Public Sub RotX(Angle As Double, RotMatrix() As Double)
'Public Sub RotZ(Angle As Double, RotMatrix() As Double)
'Public Sub BuildTransformationMatrix(Origin As InBlu_Point_3D, Orientation As Inblu_Angles, Transformation() As Double)
'Public Sub BuildFrameTransformationMatrix(Origin As InBlu_Point_3D, X_Direction As InBlu_Point_3D, Y_Direction As InBlu_Point_3D, Transformation() As Double)
'Public Sub CoordinateTransformation(ByRef Transformation() As Double, ByRef BasePosition As InBlu_Point_3D, ByRef BaseOrientation As Inblu_Angles, ByRef TransPosition As InBlu_Point_3D, ByRef TransOrientation As Inblu_Angles)
'Public Sub GetPointByTrans(ByRef Transformation() As Double, ByRef Origin As InBlu_Point_3D, ByRef Angle As Inblu_Angles)


Public Function CalculateCosPlane(ByRef Point1 As InBlu_Point_3D, ByRef Point2 As InBlu_Point_3D, ByRef Point3 As InBlu_Point_3D) As Inblu_Cos_Axes
'Calculates the director cosines of the plane given by three points
'INPUT PARAMETERS:
'   Point1: first point
'   Point2: second point
'   Point3: third point
'OUTPUT PARAMETERS:
'   Inblu_Cos_Axes: director cosines of the plane defined by the given 3 points
    
    
    'Declarations
    Dim DeltaAD(1 To 3, 1 To 3) As Double
    Dim DeltaBD(1 To 3, 1 To 3) As Double
    Dim DeltaCD(1 To 3, 1 To 3) As Double
    Dim DetDeltaAD As Double, DetDeltaBD As Double, DetDeltaCD As Double
    Dim FunRes As Boolean
    
    Dim fclCalculateCosPlane As Inblu_Cos_Axes
    Set fclCalculateCosPlane = New Inblu_Cos_Axes
    
    'Biulding matrix
    DeltaAD(1, 1) = -1
    DeltaAD(1, 2) = Point1.BaseY
    DeltaAD(1, 3) = Point1.BaseZ
    DeltaAD(2, 1) = -1
    DeltaAD(2, 2) = Point2.BaseY
    DeltaAD(2, 3) = Point2.BaseZ
    DeltaAD(3, 1) = -1
    DeltaAD(3, 2) = Point3.BaseY
    DeltaAD(3, 3) = Point3.BaseZ

    DeltaBD(1, 1) = Point1.BaseX
    DeltaBD(1, 2) = -1
    DeltaBD(1, 3) = Point1.BaseZ
    DeltaBD(2, 1) = Point2.BaseX
    DeltaBD(2, 2) = -1
    DeltaBD(2, 3) = Point2.BaseZ
    DeltaBD(3, 1) = Point3.BaseX
    DeltaBD(3, 2) = -1
    DeltaBD(3, 3) = Point3.BaseZ

    DeltaCD(1, 1) = Point1.BaseX
    DeltaCD(1, 2) = Point1.BaseY
    DeltaCD(1, 3) = -1
    DeltaCD(2, 1) = Point2.BaseX
    DeltaCD(2, 2) = Point2.BaseY
    DeltaCD(2, 3) = -1
    DeltaCD(3, 1) = Point3.BaseX
    DeltaCD(3, 2) = Point3.BaseY
    DeltaCD(3, 3) = -1
    
    'Calculation of director cosines of plane
    FunRes = Determinante(DeltaAD(), DetDeltaAD)
    fclCalculateCosPlane.Cos_XR = DetDeltaAD
        
    FunRes = Determinante(DeltaBD(), DetDeltaBD)
    fclCalculateCosPlane.Cos_YR = DetDeltaBD
    
    FunRes = Determinante(DeltaCD(), DetDeltaCD)
    fclCalculateCosPlane.Cos_ZR = DetDeltaCD
    
    Set CalculateCosPlane = fclCalculateCosPlane
    Set fclCalculateCosPlane = Nothing
 
End Function


Public Sub CompleteAxes(ByRef X_Axes_Cos As Inblu_Cos_Axes, ByRef Y_Axes_Cos As Inblu_Cos_Axes, ByRef Z_Axes_Cos As Inblu_Cos_Axes, ByRef Origin As InBlu_Point_3D, ByRef X_Direction As InBlu_Point_3D, ByRef Y_Direction As InBlu_Point_3D)
'Calculates the director cosines of the Y axis perfectly ortogonal to the X axis.
'After that completes a reference frame with the third axis (Z)
    
    'Declarations
    Dim xx As Double, xy As Double, xz As Double
    Dim yx As Double, yy As Double, yz As Double
    Dim zx As Double, zy As Double, zz As Double
    Dim a3 As Double, b3 As Double, c3 As Double
    Dim cxx As Double, cyx As Double, czx As Double
    Dim zz1 As Double, zz2 As Double, zy1 As Double, zy2 As Double, zx1 As Double, zx2 As Double
    Dim XA As Double, YA As Double, ZA As Double
    Dim Perfect As Boolean
    Dim DaElevare As Double
    Dim Test As Double
    Dim RotAlpha As Double
    Dim AlphaTarget As Double
    Dim InvTrans() As Double
    Dim Transformation(1 To 4, 1 To 4) As Double
    Dim AlphaYDir As Double
    ''''''''''''''''''''''''''''''''''''''''''''''''''
    Dim PlaneCos As Inblu_Cos_Axes
    Set PlaneCos = New Inblu_Cos_Axes
    Dim IdealPoint As InBlu_Point_3D
    Set IdealPoint = New InBlu_Point_3D
    Dim Tmp_YCos As Inblu_Cos_Axes
    Set Tmp_YCos = New Inblu_Cos_Axes
    Dim YDIdeal As InBlu_Point_3D
    Set YDIdeal = New InBlu_Point_3D
    Dim YDTIdeal As InBlu_Point_3D
    Set YDTIdeal = New InBlu_Point_3D
    Dim YDT As InBlu_Point_3D
    Set YDT = New InBlu_Point_3D
    Dim shl As Inblu_Angles
    Set shl = New Inblu_Angles
    
    'Allocations
    cxx = X_Axes_Cos.Cos_XR
    xx = X_Axes_Cos.Cos_XR

    cyx = X_Axes_Cos.Cos_YR
    xy = X_Axes_Cos.Cos_YR

    czx = X_Axes_Cos.Cos_ZR
    xz = X_Axes_Cos.Cos_ZR

    XA = Origin.BaseX
    YA = Origin.BaseY
    ZA = Origin.BaseZ
    
    'Calculation of director cosines of Y axis
    Perfect = True
    If Perfect Then
    'Calculation of director cosines perfectly ortoginal
        
        'Calculation of director cosines of the plane containing
        'the three given points
        Set PlaneCos = CalculateCosPlane(Origin, X_Direction, Y_Direction)
        a3 = PlaneCos.Cos_XR
        b3 = PlaneCos.Cos_YR
        c3 = PlaneCos.Cos_ZR
        
        'Calculation of coordinates of extreme point of versor
        DaElevare = (-2 * c3 ^ 2 * cxx ^ 3 * cyx * a3 * b3 - 2 * cyx ^ 2 * a3 ^ 3 * czx * c3 * cxx + czx ^ 2 * b3 ^ 4 * cxx ^ 2 + cyx ^ 4 * a3 ^ 2 * c3 ^ 2 + cyx ^ 2 * a3 ^ 4 * czx ^ 2 - 4 * cyx * a3 * b3 ^ 3 * cxx ^ 3 - 2 * cyx ^ 3 * a3 * b3 * cxx * c3 ^ 2 + b3 ^ 2 * cxx ^ 2 * cyx ^ 2 * c3 ^ 2 + 4 * a3 ^ 2 * czx * c3 * cxx ^ 2 * cyx * b3 - 2 * a3 * czx * c3 * cxx ^ 3 * b3 ^ 2 + b3 ^ 4 * cxx ^ 4 - 2 * czx ^ 2 * b3 ^ 3 * cyx * a3 * cxx - 2 * cyx * c3 * czx * b3 ^ 3 * cxx ^ 2 - 2 * a3 ^ 3 * czx ^ 2 * cyx * b3 * cxx + a3 ^ 2 * czx ^ 2 * b3 ^ 2 * cxx ^ 2 + 6 * cyx ^ 2 * a3 ^ 2 * b3 ^ 2 * cxx ^ 2 - 2 * cyx ^ 3 * a3 ^ 2 * c3 * czx * b3 + cyx ^ 2 * a3 ^ 2 * czx ^ 2 * b3 ^ 2 - 4 * cyx ^ 3 * a3 ^ 3 * b3 * cxx + c3 ^ 2 * cxx ^ 2 * cyx ^ 2 * a3 ^ 2 + cyx ^ 4 * a3 ^ 4 + c3 ^ 2 * cxx ^ 4 * b3 ^ 2 + 4 * cyx ^ 2 * c3 * czx * b3 ^ 2 * a3 * cxx) ^ (1 / 2)
        
        IdealPoint.BaseZ = (1 / 2) / (c3 ^ 2 * cxx ^ 2 + cyx ^ 2 * a3 ^ 2 + a3 ^ 2 * czx ^ 2 - 2 * cyx * c3 * czx * b3 + czx ^ 2 * b3 ^ 2 - 2 * a3 * czx * c3 * cxx - 2 * cyx * a3 * b3 * cxx + b3 ^ 2 * cxx ^ 2 + cyx ^ 2 * c3 ^ 2) * (2 * ZA * cyx ^ 2 * a3 ^ 2 + 2 * czx ^ 2 * b3 ^ 2 * ZA - 4 * a3 * czx * c3 * cxx * ZA + 2 * c3 ^ 2 * cxx ^ 2 * ZA + 2 * a3 ^ 2 * czx ^ 2 * ZA + 2 * ZA * b3 ^ 2 * cxx ^ 2 + 2 * cyx ^ 2 * c3 ^ 2 * ZA - 4 * ZA * cyx * a3 * b3 * cxx - 4 * cyx * c3 * czx * ZA * b3 + 2 * DaElevare)
        
        IdealPoint.BaseY = (a3 * cyx * YA - a3 * czx * IdealPoint.BaseZ + a3 * czx * ZA - YA * b3 * cxx + c3 * cxx * IdealPoint.BaseZ - c3 * cxx * ZA) / (cyx * a3 - b3 * cxx)
        
        IdealPoint.BaseX = (XA * cxx - cyx * IdealPoint.BaseY + cyx * YA - czx * IdealPoint.BaseZ + czx * ZA) / cxx
        'Calculation of director cosines of axes perfectly ortogonal to X axes,
        'and contained in the plane given by the three given points
        Set Tmp_YCos = CalculateDirectorCosines(Origin, IdealPoint)
             
        'Values allocation
        Y_Axes_Cos.Cos_XR = Tmp_YCos.Cos_XR
        'Axes Y
        Y_Axes_Cos.Cos_YR = Tmp_YCos.Cos_YR
        'Axes Z
        Y_Axes_Cos.Cos_ZR = Tmp_YCos.Cos_ZR

        'Allocations for next operations
        yx = Y_Axes_Cos.Cos_XR
        yy = Y_Axes_Cos.Cos_YR
        yz = Y_Axes_Cos.Cos_ZR

    Else
        
        'Calculation of director cosines by given points (not precise)
        yx = Y_Axes_Cos.Cos_XR
        yy = Y_Axes_Cos.Cos_YR
        yz = Y_Axes_Cos.Cos_ZR
    
    End If
    
    'Calculation of director cosines of Z axes
    zz1 = 1 / (yy ^ 2 * xz ^ 2 - 2 * yy * xz * yz * xy + yz ^ 2 * xy ^ 2 + xx ^ 2 * yz ^ 2 - 2 * xx * yz * xz * yx + xz ^ 2 * yx ^ 2 + xx ^ 2 * yy ^ 2 - 2 * xx * yy * xy * yx + xy ^ 2 * yx ^ 2) ^ (1 / 2) * (xx * yy - xy * yx)
    zz2 = -1 / (yy ^ 2 * xz ^ 2 - 2 * yy * xz * yz * xy + yz ^ 2 * xy ^ 2 + xx ^ 2 * yz ^ 2 - 2 * xx * yz * xz * yx + xz ^ 2 * yx ^ 2 + xx ^ 2 * yy ^ 2 - 2 * xx * yy * xy * yx + xy ^ 2 * yx ^ 2) ^ (1 / 2) * (xx * yy - xy * yx)

    zy1 = -zz1 * (xx * yz - xz * yx) / (xx * yy - xy * yx)
    zy2 = -zz2 * (xx * yz - xz * yx) / (xx * yy - xy * yx)

    zx1 = -(yy * zy1 + yz * zz1) / yx
    zx2 = -(yy * zy2 + yz * zz2) / yx
    
    Z_Axes_Cos.Cos_XR = zx1
    Z_Axes_Cos.Cos_YR = zy1
    Z_Axes_Cos.Cos_ZR = zz1
    
    'Axes ortogonalization
    Transformation(1, 1) = X_Axes_Cos.Cos_XR
    Transformation(1, 2) = Y_Axes_Cos.Cos_XR
    Transformation(1, 3) = Z_Axes_Cos.Cos_XR
    Transformation(1, 4) = Origin.BaseX
    Transformation(2, 1) = X_Axes_Cos.Cos_YR
    Transformation(2, 2) = Y_Axes_Cos.Cos_YR
    Transformation(2, 3) = Z_Axes_Cos.Cos_YR
    Transformation(2, 4) = Origin.BaseY
    Transformation(3, 1) = X_Axes_Cos.Cos_ZR
    Transformation(3, 2) = Y_Axes_Cos.Cos_ZR
    Transformation(3, 3) = Z_Axes_Cos.Cos_ZR
    Transformation(3, 4) = Origin.BaseZ
    Transformation(4, 1) = 0
    Transformation(4, 2) = 0
    Transformation(4, 3) = 0
    Transformation(4, 4) = 1
    
    shl.AngleType = "none"
    
    CoordinateTransformation Transformation(), Y_Direction, shl, YDT, shl
    
    AlphaYDir = 180 / PiGreco * Atan2(YDT.BaseY, YDT.BaseX)
    
    If AlphaYDir > -180 And AlphaYDir < -90 Then
        AlphaTarget = -90
        YDTIdeal.BaseX = YDT.BaseX / Cos(PiGreco / 180 * AlphaYDir) * Cos(PiGreco / 180 * AlphaTarget)
        YDTIdeal.BaseY = YDT.BaseY / Sin(PiGreco / 180 * AlphaYDir) * Sin(PiGreco / 180 * AlphaTarget)
        YDTIdeal.BaseZ = YDT.BaseZ
    ElseIf AlphaYDir > -90 And AlphaYDir < 0 Then
        AlphaTarget = -90
        YDTIdeal.BaseX = YDT.BaseX / Cos(PiGreco / 180 * AlphaYDir) * Cos(PiGreco / 180 * AlphaTarget)
        YDTIdeal.BaseY = YDT.BaseY / Sin(PiGreco / 180 * AlphaYDir) * Sin(PiGreco / 180 * AlphaTarget)
        YDTIdeal.BaseZ = YDT.BaseZ
     ElseIf AlphaYDir > 0 And AlphaYDir < 90 Then
        AlphaTarget = 90
        YDTIdeal.BaseX = YDT.BaseX / Cos(PiGreco / 180 * AlphaYDir) * Cos(PiGreco / 180 * AlphaTarget)
        YDTIdeal.BaseY = YDT.BaseY / Sin(PiGreco / 180 * AlphaYDir) * Sin(PiGreco / 180 * AlphaTarget)
        YDTIdeal.BaseZ = YDT.BaseZ
     ElseIf AlphaYDir > 90 And AlphaYDir < 180 Then
        AlphaTarget = 90
        YDTIdeal.BaseX = YDT.BaseX / Cos(PiGreco / 180 * AlphaYDir) * Cos(PiGreco / 180 * AlphaTarget)
        YDTIdeal.BaseY = YDT.BaseY / Sin(PiGreco / 180 * AlphaYDir) * Sin(PiGreco / 180 * AlphaTarget)
        YDTIdeal.BaseZ = YDT.BaseZ
     End If
  
    Inversa Transformation(), InvTrans
    
    CoordinateTransformation InvTrans, YDTIdeal, shl, YDIdeal, shl
    
    Set Y_Axes_Cos = CalculateDirectorCosines(Origin, YDIdeal)
    
    Test = Y_Axes_Cos.Cos_XR * X_Axes_Cos.Cos_XR + Y_Axes_Cos.Cos_YR * X_Axes_Cos.Cos_YR + Y_Axes_Cos.Cos_ZR * X_Axes_Cos.Cos_ZR

    If Abs(Test) > 0.000015 Then
        Set Tmp_YCos = Nothing
        Set IdealPoint = Nothing
        Set YDT = Nothing
        Set shl = Nothing
        Set YDTIdeal = Nothing
        Set YDIdeal = Nothing
        Set PlaneCos = Nothing
        Err.Number = -25
        Err.Source = "CompleteAxes"
        Err.Description = "Posizione di singolarit: cambiare il punto della direzione Y."
        Exit Sub
    End If
    
    yx = Y_Axes_Cos.Cos_XR
    yy = Y_Axes_Cos.Cos_YR
    yz = Y_Axes_Cos.Cos_ZR

    zz1 = 1 / (yy ^ 2 * xz ^ 2 - 2 * yy * xz * yz * xy + yz ^ 2 * xy ^ 2 + xx ^ 2 * yz ^ 2 - 2 * xx * yz * xz * yx + xz ^ 2 * yx ^ 2 + xx ^ 2 * yy ^ 2 - 2 * xx * yy * xy * yx + xy ^ 2 * yx ^ 2) ^ (1 / 2) * (xx * yy - xy * yx)
    zz2 = -1 / (yy ^ 2 * xz ^ 2 - 2 * yy * xz * yz * xy + yz ^ 2 * xy ^ 2 + xx ^ 2 * yz ^ 2 - 2 * xx * yz * xz * yx + xz ^ 2 * yx ^ 2 + xx ^ 2 * yy ^ 2 - 2 * xx * yy * xy * yx + xy ^ 2 * yx ^ 2) ^ (1 / 2) * (xx * yy - xy * yx)

    zy1 = -zz1 * (xx * yz - xz * yx) / (xx * yy - xy * yx)
    zy2 = -zz2 * (xx * yz - xz * yx) / (xx * yy - xy * yx)

    zx1 = -(yy * zy1 + yz * zz1) / yx
    zx2 = -(yy * zy2 + yz * zz2) / yx
    
    Z_Axes_Cos.Cos_XR = zx1
    Z_Axes_Cos.Cos_YR = zy1
    Z_Axes_Cos.Cos_ZR = zz1
    
    Set Tmp_YCos = Nothing
    Set IdealPoint = Nothing
    Set YDT = Nothing
    Set shl = Nothing
    Set YDTIdeal = Nothing
    Set YDIdeal = Nothing
    Set PlaneCos = Nothing

End Sub


Public Function CalculateDirectorCosines(ByRef Point_A As InBlu_Point_3D, ByRef Point_B As InBlu_Point_3D) As Inblu_Cos_Axes
'Given two points in the space, A and B, the function calculates the cosine
'directors of the space line that link the two points.
'INPUT PARAMETERS:
'   Point_A: first point
'   Point_B: second point
'OUTPUT PARAMETERS:
'   Inblu_Cos_Axes: cosine directors

    'Declarations
    Dim XA As Double
    Dim YA As Double
    Dim ZA As Double
    Dim XB As Double
    Dim YB As Double
    Dim ZB As Double
    Dim Delta As Double
    ''''''''''''''''''''''''''''''''''''''''''''''''''''
    Dim fclCalculateDirectorCosines As Inblu_Cos_Axes
    Set fclCalculateDirectorCosines = New Inblu_Cos_Axes
    
    On Error Resume Next
    'Allocation of coordinate values
    XA = Point_A.BaseX
    YA = Point_A.BaseY
    ZA = Point_A.BaseZ
    XB = Point_B.BaseX
    YB = Point_B.BaseY
    ZB = Point_B.BaseZ
    
    'Calculation of the space distance
    Delta = Sqr((XB - XA) ^ 2 + (YB - YA) ^ 2 + (ZB - ZA) ^ 2)
    
    'Calculation of director cosines
    fclCalculateDirectorCosines.Cos_XR = (XB - XA) / Delta
    If Err.Number <> 0 Then
        Err.Number = -9
        Err.Source = "CalculateDirectorCosines"
        Err.Description = "Errore: punti non validi per la definizione di un nuovo frame."
        Set fclCalculateDirectorCosines = Nothing
        Exit Function
    End If
    fclCalculateDirectorCosines.Cos_YR = (YB - YA) / Delta
    If Err.Number <> 0 Then
        Err.Number = -9
        Err.Source = "CalculateDirectorCosines"
        Err.Description = "Errore: punti non validi per la definizione di un nuovo frame."
        Set fclCalculateDirectorCosines = Nothing
        Exit Function
    End If
    fclCalculateDirectorCosines.Cos_ZR = (ZB - ZA) / Delta
    If Err.Number <> 0 Then
        Err.Number = -9
        Err.Source = "CalculateDirectorCosines"
        Err.Description = "Errore: punti non validi per la definizione di un nuovo frame."
        Set fclCalculateDirectorCosines = Nothing
       Exit Function
    End If
    
    Set CalculateDirectorCosines = fclCalculateDirectorCosines
    Set fclCalculateDirectorCosines = Nothing

End Function


Public Sub CoordinateTransformation(ByRef Transformation() As Double, ByRef BasePosition As InBlu_Point_3D, ByRef BaseOrientation As Inblu_Angles, ByRef TransPosition As InBlu_Point_3D, ByRef TransOrientation As Inblu_Angles)
'Given a point in the space referred to base frame and his orientation, this function calculates,
'using the transformation matrix Transformation(), the point position and orientation referred to
'the new reference frame, defined by the transformation matrix
    
    'Declarations
    Dim TmpTrans(1 To 4, 1 To 4) As Double
    Dim ResMatrix() As Double
    Dim InvTransformation() As Double
    Dim Res As Double
    Dim TmpTransformation(1 To 4, 1 To 4) As Double
    Dim I As Long, J As Long
    
    For I = 1 To 4
        For J = 1 To 4
            TmpTransformation(I, J) = Transformation(I, J)
        Next J
    Next I
    
    'Get transformation matrix by point and orientations
    BuildTransformationMatrix BasePosition, BaseOrientation, TmpTrans()
    'Build tranSf^(-1)
    Res = Inversa(TmpTransformation, InvTransformation)
    'Coordinate transformation
    ResMatrix = MMol(InvTransformation, TmpTrans)
    'Calculate Origin and orientation of new transformation
    GetPointByTrans ResMatrix, TransPosition, TransOrientation
    
End Sub


Public Sub BuildFrameTransformationMatrix(Origin As InBlu_Point_3D, X_Direction As InBlu_Point_3D, Y_Direction As InBlu_Point_3D, Transformation() As Double)
'Calculates the transformation matrix associated to a reference frame defined
'by 3 points
'INPUT PARAMETERS:
'   Origin: origin point of the new reference frame
'   X_Direction: point representing the X direction of the new frame
'   Y_Direction: point representing the Y direction of the new frame
'OUTPUT PARAMETERS:
'   BuildTransformationMatrix: transformation matrix associated to the new
'   reference frame

    'Declarations
    Dim Asse_X As Inblu_Cos_Axes
    Set Asse_X = New Inblu_Cos_Axes
    Dim Asse_Y As Inblu_Cos_Axes
    Set Asse_Y = New Inblu_Cos_Axes
    Dim Asse_Z As Inblu_Cos_Axes
    Set Asse_Z = New Inblu_Cos_Axes

    'Calculation of director cosines of the two vresors
    Set Asse_X = CalculateDirectorCosines(Origin, X_Direction)
    If Err.Number <> 0 Then
        Set Asse_X = Nothing
        Set Asse_Y = Nothing
        Set Asse_Z = Nothing
        Exit Sub
    End If
    
    Set Asse_Y = CalculateDirectorCosines(Origin, Y_Direction)
        If Err.Number <> 0 Then
        Set Asse_X = Nothing
        Set Asse_Y = Nothing
        Set Asse_Z = Nothing
        Exit Sub
    End If

    'Completion of the frame
    CompleteAxes Asse_X, Asse_Y, Asse_Z, Origin, X_Direction, Y_Direction
    If Err.Number <> 0 Then
        Set Asse_X = Nothing
        Set Asse_Y = Nothing
        Set Asse_Z = Nothing
        Exit Sub
    End If
    'Calculation of transformation matrix
    Transformation(1, 1) = Asse_X.Cos_XR
    Transformation(1, 2) = Asse_Y.Cos_XR
    Transformation(1, 3) = Asse_Z.Cos_XR
    Transformation(1, 4) = Origin.X
    Transformation(2, 1) = Asse_X.Cos_YR
    Transformation(2, 2) = Asse_Y.Cos_YR
    Transformation(2, 3) = Asse_Z.Cos_YR
    Transformation(2, 4) = Origin.Y
    Transformation(3, 1) = Asse_X.Cos_ZR
    Transformation(3, 2) = Asse_Y.Cos_ZR
    Transformation(3, 3) = Asse_Z.Cos_ZR
    Transformation(3, 4) = Origin.Z
    Transformation(4, 1) = 0
    Transformation(4, 2) = 0
    Transformation(4, 3) = 0
    Transformation(4, 4) = 1

    Set Asse_X = Nothing
    Set Asse_Y = Nothing
    Set Asse_Z = Nothing

End Sub


Public Sub RotZ(Angle As Double, RotMatrix() As Double)
'Given an angle expressed in degrees, calculates the rotation
'matrix along z axis
       
    RotMatrix(1, 1) = Cos(PiGreco / 180 * Angle)
    RotMatrix(1, 2) = -Sin(PiGreco / 180 * Angle)
    RotMatrix(1, 3) = 0
    RotMatrix(1, 4) = 0
    RotMatrix(2, 1) = Sin(PiGreco / 180 * Angle)
    RotMatrix(2, 2) = Cos(PiGreco / 180 * Angle)
    RotMatrix(2, 3) = 0
    RotMatrix(2, 4) = 0
    RotMatrix(3, 1) = 0
    RotMatrix(3, 2) = 0
    RotMatrix(3, 3) = 1
    RotMatrix(3, 4) = 0
    RotMatrix(4, 1) = 0
    RotMatrix(4, 2) = 0
    RotMatrix(4, 3) = 0
    RotMatrix(4, 4) = 1

End Sub

Public Sub RotX(Angle As Double, RotMatrix() As Double)
'Given an angle expressed in degrees, calculates the rotation
'matrix along x axis
    
    RotMatrix(1, 1) = 1
    RotMatrix(1, 2) = 0
    RotMatrix(1, 3) = 0
    RotMatrix(1, 4) = 0
    RotMatrix(2, 1) = 0
    RotMatrix(2, 2) = Cos(PiGreco / 180 * Angle)
    RotMatrix(2, 3) = -Sin(PiGreco / 180 * Angle)
    RotMatrix(2, 4) = 0
    RotMatrix(3, 1) = 0
    RotMatrix(3, 2) = Sin(PiGreco / 180 * Angle)
    RotMatrix(3, 3) = Cos(PiGreco / 180 * Angle)
    RotMatrix(3, 4) = 0
    RotMatrix(4, 1) = 0
    RotMatrix(4, 2) = 0
    RotMatrix(4, 3) = 0
    RotMatrix(4, 4) = 1

End Sub


Public Sub RotY(Angle As Double, RotMatrix() As Double)
'Given an angle expressed in degrees, calculates the rotation
'matrix along y axis

    RotMatrix(1, 1) = Cos(PiGreco / 180 * Angle)
    RotMatrix(1, 2) = 0
    RotMatrix(1, 3) = Sin(PiGreco / 180 * Angle)
    RotMatrix(1, 4) = 0
    RotMatrix(2, 1) = 0
    RotMatrix(2, 2) = 1
    RotMatrix(2, 3) = 0
    RotMatrix(2, 4) = 0
    RotMatrix(3, 1) = -Sin(PiGreco / 180 * Angle)
    RotMatrix(3, 2) = 0
    RotMatrix(3, 3) = Cos(PiGreco / 180 * Angle)
    RotMatrix(3, 4) = 0
    RotMatrix(4, 1) = 0
    RotMatrix(4, 2) = 0
    RotMatrix(4, 3) = 0
    RotMatrix(4, 4) = 1

End Sub


Public Sub Trasl(X As Double, Y As Double, Z As Double, TraslMatrix() As Double)
'Given a point, build the transformation matrix without rotations

    TraslMatrix(1, 1) = 1
    TraslMatrix(1, 2) = 0
    TraslMatrix(1, 3) = 0
    TraslMatrix(1, 4) = X
    TraslMatrix(2, 1) = 0
    TraslMatrix(2, 2) = 1
    TraslMatrix(2, 3) = 0
    TraslMatrix(2, 4) = Y
    TraslMatrix(3, 1) = 0
    TraslMatrix(3, 2) = 0
    TraslMatrix(3, 3) = 1
    TraslMatrix(3, 4) = Z
    TraslMatrix(4, 1) = 0
    TraslMatrix(4, 2) = 0
    TraslMatrix(4, 3) = 0
    TraslMatrix(4, 4) = 1

End Sub


Public Sub BuildTransformationMatrix(Origin As InBlu_Point_3D, Orientation As Inblu_Angles, Transformation() As Double)
'Given a point in the space (frame origin) and an orientation (ZYZ, XYZ, ...)
'calculates the transformation matrix associated to the frame
    
    
    Dim RSZ(1 To 4, 1 To 4) As Double
    Dim RY(1 To 4, 1 To 4) As Double
    Dim RZ(1 To 4, 1 To 4) As Double
    Dim RX(1 To 4, 1 To 4) As Double
    Dim TraslMatrix(1 To 4, 1 To 4) As Double
    Dim TmpMatrix1() As Double
    Dim TmpMatrix2() As Double
    Dim TmpMatrix3() As Double
    Dim I As Long, J As Long
    
    If Orientation.AngleType = "ZYZ" Then
        RotZ Orientation.First, RZ()
        RotY Orientation.Second, RY()
        RotZ Orientation.Third, RSZ()
        TmpMatrix1 = MMol(RZ, RY)
        TmpMatrix2 = MMol(TmpMatrix1, RSZ)
    ElseIf Orientation.AngleType = "XYZ" Then
        RotX Orientation.First, RX()
        RotY Orientation.Second, RY()
        RotZ Orientation.Third, RZ()
        TmpMatrix1 = MMol(RX, RY)
        TmpMatrix2 = MMol(TmpMatrix1, RZ)
    ElseIf Orientation.AngleType = "none" Then
        RotX 0, RX()
        RotY 0, RY()
        RotZ 0, RZ()
        TmpMatrix1 = MMol(RX, RY)
        TmpMatrix2 = MMol(TmpMatrix1, RZ)
    End If
    
    Trasl Origin.BaseX, Origin.BaseY, Origin.BaseZ, TraslMatrix
    
    TmpMatrix3 = MMol(TraslMatrix, TmpMatrix2)
    'Make a copy of transformation matrix
    For I = 1 To 4
        For J = 1 To 4
            Transformation(I, J) = TmpMatrix3(I, J)
        Next J
    Next I
    
End Sub


Public Sub GetPointByTrans(ByRef Transformation() As Double, ByRef Origin As InBlu_Point_3D, ByRef Angle As Inblu_Angles)
'Given a transgformation matrix, extract the origin and the
'orientation angles (degrees), as specified in the property
'AngleType of Angle class
    
    If Angle.AngleType = "ZYZ" Then
        Angle.First = 180 / PiGreco * Atan2(Transformation(2, 3), Transformation(1, 3))
        Angle.Second = 180 / PiGreco * Atan2(Sqr(Transformation(1, 3) ^ 2 + Transformation(2, 3) ^ 2), Transformation(3, 3))
        Angle.Third = 180 / PiGreco * Atan2(Transformation(3, 2), -Transformation(3, 1))
        If Abs(Transformation(1, 3)) < 0.00001 And Abs(Transformation(2, 3)) < 0.00001 And Abs(Transformation(3, 1)) < 0.00001 And Abs(Transformation(3, 2)) < 0.00001 Then
            Angle.First = 180 / PiGreco * Atan2(-Transformation(1, 2), Transformation(1, 1))
            Angle.Second = 0
            Angle.Third = 0
        End If
    ElseIf Angle.AngleType = "ZYX" Then
        Angle.First = 180 / PiGreco * Atan2(Transformation(2, 1), Transformation(1, 1))
        Angle.Second = 180 / PiGreco * Atan2(-Transformation(3, 1), Sqr(Transformation(3, 2) ^ 2 + Transformation(3, 3) ^ 2))
        Angle.Third = 180 / PiGreco * Atan2(Transformation(3, 2), Transformation(3, 3))
    End If
    
    Origin.BaseX = Transformation(1, 4)
    Origin.BaseY = Transformation(2, 4)
    Origin.BaseZ = Transformation(3, 4)
    
End Sub


