Attribute VB_Name = "InBlu_Common_Function"
Option Explicit

Public Declare Function Inp Lib "inpout32.dll" _
Alias "Inp32" (ByVal PortAddress As Integer) As Integer

Public Declare Sub Out Lib "inpout32.dll" _
Alias "Out32" (ByVal PortAddress As Integer, ByVal Value As Integer)
Public Declare Function SendMessage Lib "user32" _
Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const EM_CANUNDO = &HC6
Private Const EM_UNDO = &HC7
Private Const EM_EMPTYUNDOBUFFER = &HCD

Public Function Undo_TextBox_Value(txt As TextBox) As Boolean

    If txt Is Nothing Then Exit Function
    
    'Declarations
    Dim Res As Boolean
    
    Res = SendMessage(txt.hwnd, EM_CANUNDO, 0, ByVal 0&)
    
    If Res Then
         SendMessage txt.hwnd, EM_UNDO, 0, ByVal 0&
         SendMessage txt.hwnd, EM_EMPTYUNDOBUFFER, 0, ByVal 0&
         Undo_TextBox_Value = True
    End If
End Function

Public Function NumericString(KeyAscii As Integer) As Boolean
'This function check if a character is numeric
'or a control character
    Select Case KeyAscii
        Case 8, 13, 27 To 31, 45, 46, 48 To 57 'Some control and numeric characters
            NumericString = True
        Case Else
            KeyAscii = 0
            NumericString = False
    End Select
End Function


Public Function ArrayCopyDbl(FirstArray() As Double, SecondArray() As Double, Optional Constant As Double = 1)
'Function to copy firstarray in the second array
'INPUT PARAMETER:
    'FirstArray:Array that contains the values to copy
'OUTPUT PARAMETER:
    'SecondArray:Destination array of copied values

    'Declarations
    Dim I As Long
  
    For I = LBound(FirstArray()) To UBound(FirstArray())
        ReDim Preserve SecondArray(I)
        SecondArray(I) = FirstArray(I) * Constant
    Next I
  
End Function


Public Function ArrayCopyLng(FirstArray() As Long, SecondArray() As Long, Optional Constant As Double = 1)
'Function to copy firstarray in the second array
'INPUT PARAMETER:
    'FirstArray:Array that contains the values to copy
'OUTPUT PARAMETER:
    'SecondArray:Destination array of copied values

    'Declarations
    Dim I As Long
  
    For I = LBound(FirstArray()) To UBound(FirstArray())
        ReDim Preserve SecondArray(I)
        SecondArray(I) = FirstArray(I) * 1
    Next I
  
End Function


Public Function Find_Min_In_Array(InsiemePunti() As Double, Optional Indice As Long) As Double
'Funzione per il calcolo del valore minimo
'in un insieme di valori
'PARAMETRI D'INGRESSO:
'     InsiemePunti : insieme dei valori tra cui eseguire la ricerca
'PARAMETRI D'USCITA
'     MinVal :risultato della ricrca contenente il valore minimo

    'Dichiarazione Variabili
    Dim LimInfArray As Integer
    Dim LimSupArray As Integer
    Dim Contatore As Long
    Dim Minimo As Double
    
    'Calcolo del valore minimo
    LimSupArray = UBound(InsiemePunti())
    LimInfArray = LBound(InsiemePunti())
    Minimo = InsiemePunti(LimInfArray)

    For Contatore = LimInfArray + 1 To LimSupArray
        If InsiemePunti(Contatore) < Minimo Then
            Minimo = InsiemePunti(Contatore)
            Indice = Contatore
        End If
    Next Contatore
    Find_Min_In_Array = Minimo

End Function


Public Function Find_Max_In_Array(InsiemePunti() As Double, Optional Indice As Long) As Double
'Funzione per il calcolo del valore massimo
'in un insieme di valori
'PARAMETRI D'INGRESSO:
'     InsiemePunti : insieme dei valori tra cui eseguire la ricerca
'PARAMETRI D'USCITA
'     MaxVal :risultato della ricrca contenente il valore massimo

    'Dichiarazione Variabili
    Dim LimInfArray As Integer
    Dim LimSupArray As Integer
    Dim Contatore As Long
    Dim Massimo As Double

    'Calcolo del valore minimo
    LimSupArray = UBound(InsiemePunti())
    LimInfArray = LBound(InsiemePunti())
    Massimo = InsiemePunti(LimInfArray)

    For Contatore = LimInfArray + 1 To LimSupArray
        If InsiemePunti(Contatore) > Massimo Then
            Massimo = InsiemePunti(Contatore)
            Indice = Contatore
        End If
    Next Contatore
    Find_Max_In_Array = Massimo

End Function

Public Function Quick_Find_Max(ByVal A_Element As Double, ByVal B_Element As Double) As Double
'Return the maximum value checking two points
'INPUT PARAMETER:
'               A_Element:First element to compare
'               B_Element:Second element to compare
'OUTPUT PARAMETER:
'               Quick_Find_Max:Maximum value checking two points
    
    
    If A_Element >= B_Element Then
        
        Quick_Find_Max = A_Element
        
    Else
    
        Quick_Find_Max = B_Element
    
    End If
    
End Function

Public Function Quick_Find_Min(ByVal A_Element As Double, ByVal B_Element As Double) As Double
'Return the minimum value checking two points
'INPUT PARAMETER:
'               A_Element:First element to compare
'               B_Element:Second element to compare
'OUTPUT PARAMETER:
'               Quick_Find_Min:Minimum value checking two points
    
    
    If A_Element <= B_Element Then
        
        Quick_Find_Min = A_Element
        
    Else
    
        Quick_Find_Min = B_Element
    
    End If
    
End Function

Public Function Find_Center(ByVal MinElement As Variant, ByVal MaxElement As Variant) As Variant
'Return the middle value between two elements
'INPUT PARAMETER:
'               MinElement:Element with minimum value
'               MaxElement:Element with maximum value
'OUTPUT PARAMETER:
'               Find_Center:Middle value between two elements

            'Find center
            Find_Center = (MinElement + MaxElement) / 2
    
End Function

Public Sub SwapIndexArray(InitialArray() As P_Type_3D, ArrayReturned() As P_Type_3D, ByVal NewStartIndex As Long)
'Function to shift index of array starting from zero
'INPUT PARAMETER:
'               InitialArray:Array that must to be swapped
'               ArrayReturned:Array swapped


    'Declarations
    Dim I As Long
    Dim UpperLimit As Long
    Dim LowerLimit As Long
    Dim Distance As Long
    
    'Find limit of initial array
    UpperLimit = UBound(InitialArray())
    LowerLimit = LBound(InitialArray())
    
    'Calculate the offset from old index and new index
    Distance = NewStartIndex - LowerLimit
    
    ReDim ArrayReturned(UpperLimit + Distance)
    
    'Swap Array
    For I = LowerLimit To UpperLimit
    
        ArrayReturned(I + Distance) = InitialArray(I)
         
    Next I
    
End Sub

Public Function Distance_3D(FirstPoint As P_Type_3D, SecondPoint As P_Type_3D) As Double
'Function that calculate the distance between two points in 3D
'INPUT PARAMETER:
'               FirstPoint:First point's coordinates
'               SecondPoint:Second point's coordinates
'OUTPUT PARAMETER:
'               Distance_3D:Distance between points

    Distance_3D = Sqr((SecondPoint.X - FirstPoint.X) ^ 2 + (SecondPoint.Y - FirstPoint.Y) ^ 2 + _
                    (SecondPoint.Z - FirstPoint.Z) ^ 2)

End Function

Public Sub SpinRotationFilter(ByVal Context As Object, XCoordinate As Double, YCoordinate As Double, ZCoordinate As Double)
'This function is used to rotate around a center a point.
'Center coordinate is properties of context.
'Angle for Spin rotation is properties of context.
'Is supposed that the rappresentation plane is "YZ" when all angle
'rotation are zeros.
'INPUT PARAMETER:
'               Context:Where the point is contained
'               XCoordinate:X coordinate of point
'               YCoordinate:Y coordinate of point
'               ZCoordinate:Z coordinate of point

    'Declarations
    Dim CosAlpha As Double, CosBeta As Double, CosGamma As Double
    Dim SinAlpha As Double, SinBeta As Double, SinGamma As Double
    Dim Alpha As Double, Beta As Double
    Dim Xc As Double, Yc As Double, Zc As Double
    
    '****************************************************
    'ATTENTION: Angle for Cos and Sin function
    'must to be expressed in Radiant.In our case
    'the user put an angle in degrees and then
    'is converted in radiant by formule :Angle*(Pi/180)
    '****************************************************
    Alpha = Context.SpinScreenYAngle * (PiGreco / 180)
    Beta = Context.SpinScreenXAngle * (PiGreco / 180)
    
    CosAlpha = Cos(Alpha)
    SinAlpha = Sin(Alpha)
    CosBeta = Cos(Beta)
    SinBeta = Sin(Beta)
      
    Xc = Context.Xcenter
    Yc = Context.YCenter
    Zc = Context.ZCenter
    'AngleZRotation=alpha
    'AngleYRotation=beta
    'Xc=X center
    'Yc=Y center
    'Zc=Z center
    'Xo,Yo,Zo= Original coordinates
    'New Y=[(Yc+(Yo-Yc)*cos(alpha))+(Xc+(Xo-Xc)*sin(alpha))]
    YCoordinate = (Yc + ((YCoordinate - Yc) * CosAlpha)) + _
                (((XCoordinate - Xc) * SinAlpha))
                    
    'New Z=[((Yo-Yc)*sin(alpha))*sin(beta)-((Xo-Xc)*cos(alpha))*sin(beta)+(Zc+(Zo-Zc)*cos(beta))]
    ZCoordinate = (((YCoordinate - Yc) * SinAlpha) * SinBeta) - (((XCoordinate - Xc) * CosAlpha) * SinBeta) + _
                (Zc + (ZCoordinate - Zc) * CosBeta)


End Sub

Public Function Rotation_Around_A_Center(ArrPtsX() As Double, ArrPtsY() As Double, ArrPtsZ() As Double, _
                                    ByVal Xcenter As Double, ByVal YCenter As Double, ByVal ZCenter As Double, _
                                    ByVal YAngle As Double, ByVal XAngle As Double) As Double()
'Function to draw a point
'INPUT PARAMETER:
'               Context : Where to draw this point

    Dim CosAlpha As Double, CosBeta As Double, CosGamma As Double
    Dim SinAlpha As Double, SinBeta As Double, SinGamma As Double
    Dim I As Long, TempRotZ As Double, TempRotY As Double
        
    '****************************************************
    'ATTENTION: Angle for Cos and Sin function
    'must to be expressed in Radiant.In our case
    'the user put an angle in degrees and then
    'is converted in radiant by formule :Angle*(Pi/180)
    '****************************************************
    CosAlpha = Cos(YAngle * (PiGreco / 180))
    SinAlpha = Sin(YAngle * (PiGreco / 180))
    CosBeta = Cos(XAngle * (PiGreco / 180))
    SinBeta = Sin(XAngle * (PiGreco / 180))
       
       
    For I = LBound(ArrPtsX()) To UBound(ArrPtsX())
    
        'AngleZRotation=alpha
        'AngleYRotation=beta
        'Xc=X center
        'Yc=Y center
        'Zc=Z center
        'Xo,Yo,Zo= Original coordinates
        'New Y=[(Yc+(Yo-Yc)*cos(alpha))+((Xo-Xc)*sin(alpha))]
        TempRotZ = (YCenter + ((ArrPtsY(I) - YCenter) * CosAlpha)) + _
                    (((ArrPtsX(I) - Xcenter) * SinAlpha))
                    
        'New Z=[((Yo-Yc)*sin(alpha))*sin(beta)-((Xo-Xc)*cos(alpha))*sin(beta)+(Zc+(Zo-Zc)*cos(beta))]
        TempRotY = (((ArrPtsY(I) - YCenter) * SinAlpha) * SinBeta) - (((ArrPtsX(I) - Xcenter) * CosAlpha) * SinBeta) + _
                    (ZCenter + (ArrPtsZ(I) - ZCenter) * CosBeta)

    Next I
    
End Function

Public Function Write_Speed_Associations(ByVal R_Speed As Long) As Long

    'Declarations
    Dim SpeedColour As Long

    Select Case R_Speed
    
        Case 100
        
            SpeedColour = RGB(200, 127, 50)
        
        Case 200
        
            SpeedColour = RGB(0, 127, 127)
        
        Case 300
        
            SpeedColour = RGB(127, 0, 200)
        
        Case 400
        
            SpeedColour = RGB(127, 0, 0)
        
        Case 500
        
            SpeedColour = RGB(50, 50, 200)
       
       Case 600
        
            SpeedColour = RGB(0, 127, 0)
        
        Case 700
        
            SpeedColour = RGB(127, 220, 127)
        
        Case 800
        
            SpeedColour = RGB(0, 0, 0)
            
        Case 900
        
            SpeedColour = RGB(255, 127, 0)
        
'        Case 1000
        Case Else
            SpeedColour = RGB(0, 255, 255)
        
'        Case 1100
'
'            SpeedColour = RGB(255, 0, 127)
'
'        Case 1200
'
'            SpeedColour = RGB(0, 255, 127)
'
'        Case 1300
'
'            SpeedColour = RGB(220, 127, 255)
'
'        Case 1400
'
'            SpeedColour = RGB(0, 0, 255)
'
'        Case 1500
'
'            SpeedColour = RGB(255, 220, 0)

    End Select

    Write_Speed_Associations = SpeedColour
    
End Function

Public Function Read_Speed_Associations(ByVal R_Speed As Long) As String

    'Declarations
    Dim SpeedColour As String

    Select Case R_Speed
    
        Case RGB(200, 127, 50)
        
            SpeedColour = "100"
        
        Case RGB(0, 127, 127)
        
            SpeedColour = "200"
        
        Case RGB(127, 0, 200)
        
            SpeedColour = "300"
        
        Case RGB(127, 0, 0)
        
            SpeedColour = "400"
        
        Case RGB(50, 50, 200)
        
            SpeedColour = "500"
       
       Case RGB(0, 127, 0)
        
            SpeedColour = "600"
        
        Case RGB(127, 220, 127)
        
            SpeedColour = "700"
        
        Case RGB(0, 0, 0)
        
            SpeedColour = "800"
            
        Case RGB(255, 127, 0)
        
            SpeedColour = "900"
        
        Case RGB(0, 255, 255)
        
            SpeedColour = "1000"
        
        Case 255
            
            SpeedColour = "1000"
        
'        Case RGB(255, 0, 127)
'
'            SpeedColour = "1000"
''
''            SpeedColour = "1100"
'
'        Case RGB(0, 255, 127)
'
'            SpeedColour = "1000"
''            SpeedColour = "1200"
'
'        Case RGB(220, 127, 255)
'
'            SpeedColour = "1000"
''            SpeedColour = "1300"
'
'        Case RGB(0, 0, 255)
'
'            SpeedColour = "1000"
''            SpeedColour = "1400"
'
'        Case RGB(255, 220, 0)
'
'            SpeedColour = "1000"
''            SpeedColour = "1500"

    End Select

    Read_Speed_Associations = SpeedColour
    
End Function

